#!/usr/bin/python
# -*- coding: utf-8 -*-
procfile=file('proclist.txt')
sumfile=file('sumresults.dat')
sumproc={}
mean={}
error={}
fileproc={}
i=0
j=0
xsec=0.0
errtot=0.0
while True:
  line=sumfile.readline()
  if len(line)==0:
    break
  parts=line.split()
  i=i+1
  mean[i]=float(parts[0])
  xsec=xsec+mean[i]
  error[i]=float(parts[1])
  errtot=errtot+error[i]
  sumproc[i]=parts[2]
while True:
  line=procfile.readline()
  if len(line)==0:
    break
  j=j+1
  parts=line.split("\n")
  fileproc[j]=parts[0]  
sumfile.seek(0)
procfile.seek(0)
if i<175:
  print 175-i, ' processes are missing: '
  for k in range(1,176):
    ok=False
    sumfile.seek(0)
    while True:
      line=sumfile.readline()
      if len(line)==0:
	break
      if line.find(fileproc[k])>0:
	ok=True
    if ok==False:
      print fileproc[k]
print ' '
print 'Now analyzing the results'
print 'Type in the percentage'
percent=input()
percent=percent/100.0
fulllist=[]
for k in range(1,i+1):
  fulllist.append([mean[k],error[k],sumproc[k]])
fulllist1=sorted(fulllist, key=lambda number: abs(number[0]),reverse=True)
fulllist2=sorted(fulllist, key=lambda number: abs(number[1]),reverse=True)
#fulllist1=sorted(fulllist,reverse=True)
limit=0.0
l=0
print 'Total cross section: ',xsec,' +- ',errtot,' pb.'
print ' '
print ' The following subprocesses account for ', percent*100.0,' % of the cross section.'
while abs(limit)<abs(percent*xsec):
  limit=limit+fulllist1[l][0]
  print fulllist1[l][0],' ', fulllist1[l][1],' ',fulllist1[l][2]
  l=l+1
print ' '
print 'These ',l,' subprocesses account for ', abs(limit/xsec)*100.0,' %.'
print ' '
print ' '
limit=0.0
l=0
print ' The following subprocesses account for ', percent*100.0,' % of the total error.'
while abs(limit)<abs(percent*errtot):
  limit=limit+fulllist2[l][1]
  print fulllist2[l][0],' ', fulllist2[l][1],' ',fulllist2[l][2]
  l=l+1
print ' '
print 'These ',l,' subprocesses account for ', abs(limit/errtot)*100.0,' %.'
