      Subroutine getjets(P,jetp,njets,P1)
      implicit none
      include 'nexternal.inc'
      include 'jets.inc'
      include 'genps.inc'
      include 'maxamps.inc'


c Arguments
      real*8 P(0:3,nexternal), jetp(4,nexternal), P1(0:3,nexternal)
      integer njets

c Global
      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)
      logical isjet
      include 'leshouche.inc'
      logical is_jet(nexternal)
      common/jetinfo/is_jet


c Local
      real*8 pjet(4,nexternal)
      integer i,j,k


      j=1
      do i=nincoming+1, nexternal
       if (isjet(idup(i,1))) then
c        is_jet(i)=.true.
        pjet(4,j)=P(0,i)
        pjet(1,j)=P(1,i)
        pjet(2,j)=P(2,i)
        pjet(3,j)=P(3,i)
        j=j+1
c       else
c        is_jet(i)=.false.
       endif
      enddo
      is_jet(3)=.false.
      is_jet(4)=.false.
      is_jet(5)=.true.
      is_jet(6)=.true.

      if(maxjets.ne.(j-1)) then
       print*, 'Error in getjets', maxjets,j
       stop
      endif

c      print*, 'original Impuls'
c      print*, p(0,1),p(1,1),p(2,1),p(3,1)
c      print*, p(0,2),p(1,2),p(2,2),p(3,2)
c      print*, p(0,3),p(1,3),p(2,3),p(3,3)
c      print*, p(0,4),p(1,4),p(2,4),p(3,4)
c      print*, p(0,5),p(1,5),p(2,5),p(3,5)
c      print*, p(0,6),p(1,6),p(2,6),p(3,6)
c      print*, ' '

      call fastjetppgenkt(pjet,maxjets,jetR,palg,jetp,njets)
      do i=njets+1,maxjets
        jetp(:,i)=0d0
      enddo
c      print*, 'nach jet algorithmus'
c      print*, 'njets', njets
c      print*, jetp(4,1),jetp(1,1),jetp(2,1),jetp(3,1)
c      print*, jetp(4,2),jetp(1,2),jetp(2,2),jetp(3,2)
c      print*, jetp(4,3),jetp(1,3),jetp(2,3),jetp(3,3)
c      print*, ' '
c      print*, ' '

      do i=njets+1,nexternal
       do j=1,4
        jetp(j,i)=0d0
       enddo
      enddo

      do i=1,nincoming
       do j=0,3
        p1(j,i)=p(j,i)
       enddo
      enddo

      k=1
      do i= nincoming+1, nexternal
       if (.not. is_jet(i)) then
        do j=0,3
         p1(j,i)=p(j,i)
        enddo
       elseif (is_jet(i)) then
        do j=1,3
         p1(j,i)=jetp(j,k)
        enddo         
         p1(0,i)=jetp(4,k)
         k=k+1
       endif
      enddo

c      print*, 'Impuls p1'
c      print*, p1(0,1),p1(1,1),p1(2,1),p1(3,1)
c      print*, p1(0,2),p1(1,2),p1(2,2),p1(3,2)
c      print*, p1(0,3),p1(1,3),p1(2,3),p1(3,3)
c      print*, p1(0,4),p1(1,4),p1(2,4),p1(3,4)
c      print*, p1(0,5),p1(1,5),p1(2,5),p1(3,5)
c      print*, p1(0,6),p1(1,6),p1(2,6),p1(3,6)
c      print*, ' '
c      print*, ' '


      end


      Subroutine getjets1(P,jetp,njets,P1)
      implicit none
      include 'nexternal.inc'
      include 'jets.inc'
      include 'genps.inc'
      include 'maxamps.inc'


c Arguments
      real*8 P(0:3,nexternal), jetp(4,nexternal), P1(0:3,nexternal)
      integer njets

c Global
      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)
      logical isjet
      include 'leshouche.inc'
      logical is_jet(nexternal)
      common/jetinfo/is_jet


c Local
      real*8 pjet(4,nexternal)
      integer i,j,k


      j=1
      do i=nincoming+1, nexternal
       if (isjet(idup(i,1))) then
        is_jet(i)=.true.
        pjet(4,j)=P(0,i)
        pjet(1,j)=P(1,i)
        pjet(2,j)=P(2,i)
        pjet(3,j)=P(3,i)
        j=j+1
       else
        is_jet(i)=.false.
       endif
      enddo



c      print*, 'original Impuls'
c      print*, p(0,1),p(1,1),p(2,1),p(3,1)
c      print*, p(0,2),p(1,2),p(2,2),p(3,2)
c      print*, p(0,3),p(1,3),p(2,3),p(3,3)
c      print*, p(0,4),p(1,4),p(2,4),p(3,4)
c      print*, p(0,5),p(1,5),p(2,5),p(3,5)
c      print*, p(0,6),p(1,6),p(2,6),p(3,6)
c      print*, ' '

      call fastjetppgenkt(pjet,4,jetR,palg,jetp,njets)
      do i=njets+1,4
        jetp(:,i)=0d0
      enddo
c      print*, 'nach jet algorithmus'
c      print*, 'njets', njets
c      print*, jetp(4,1),jetp(1,1),jetp(2,1),jetp(3,1)
c      print*, jetp(4,2),jetp(1,2),jetp(2,2),jetp(3,2)
c      print*, jetp(4,3),jetp(1,3),jetp(2,3),jetp(3,3)
c      print*, ' '

      do i=njets+1,nexternal
       do j=1,4
        jetp(j,i)=0d0
       enddo
      enddo

      do i=1,nincoming
       do j=0,3
        p1(j,i)=p(j,i)
       enddo
      enddo

      k=1
      do i= nincoming+1, nexternal
       if (.not. is_jet(i)) then
        do j=0,3
         p1(j,i)=p(j,i)
        enddo
       elseif (is_jet(i)) then
        do j=1,3
         p1(j,i)=jetp(j,k)
        enddo         
         p1(0,i)=jetp(4,k)
         k=k+1
       endif
      enddo

c      print*, 'Impuls p1'
c      print*, p1(0,1),p1(1,1),p1(2,1),p1(3,1)
c      print*, p1(0,2),p1(1,2),p1(2,2),p1(3,2)
c      print*, p1(0,3),p1(1,3),p1(2,3),p1(3,3)
c      print*, p1(0,4),p1(1,4),p1(2,4),p1(3,4)
c      print*, p1(0,5),p1(1,5),p1(2,5),p1(3,5)
c      print*, p1(0,6),p1(1,6),p1(2,6),p1(3,6)
c      print*, ' '
c      print*, ' '


      end

