module     dgaad_d95h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d95h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd95h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc95(54)
      complex(ki) :: Qspe2
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspvae2k4
      complex(ki) :: Qspvae3k4
      complex(ki) :: Qspvak4e2
      complex(ki) :: Qspvak4e3
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvae2k1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvak3k4
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspk3
      complex(ki) :: Qspvak4k3
      complex(ki) :: Qspvak4k2
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspvak2k4
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspk2
      Qspe2 = dotproduct(Q,e2)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspvae2k4 = dotproduct(Q,spvae2k4)
      Qspvae3k4 = dotproduct(Q,spvae3k4)
      Qspvak4e2 = dotproduct(Q,spvak4e2)
      Qspvak4e3 = dotproduct(Q,spvak4e3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      QspQ = dotproduct(Q,Q)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspk3 = dotproduct(Q,k3)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      Qspvak4k2 = dotproduct(Q,spvak4k2)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspk2 = dotproduct(Q,k2)
      acc95(1)=abb95(4)
      acc95(2)=abb95(5)
      acc95(3)=abb95(6)
      acc95(4)=abb95(7)
      acc95(5)=abb95(8)
      acc95(6)=abb95(9)
      acc95(7)=abb95(10)
      acc95(8)=abb95(11)
      acc95(9)=abb95(12)
      acc95(10)=abb95(13)
      acc95(11)=abb95(14)
      acc95(12)=abb95(15)
      acc95(13)=abb95(16)
      acc95(14)=abb95(17)
      acc95(15)=abb95(18)
      acc95(16)=abb95(19)
      acc95(17)=abb95(20)
      acc95(18)=abb95(21)
      acc95(19)=abb95(22)
      acc95(20)=abb95(23)
      acc95(21)=abb95(24)
      acc95(22)=abb95(26)
      acc95(23)=abb95(27)
      acc95(24)=abb95(28)
      acc95(25)=abb95(29)
      acc95(26)=abb95(30)
      acc95(27)=abb95(31)
      acc95(28)=abb95(32)
      acc95(29)=abb95(34)
      acc95(30)=abb95(35)
      acc95(31)=abb95(38)
      acc95(32)=abb95(39)
      acc95(33)=abb95(40)
      acc95(34)=abb95(41)
      acc95(35)=abb95(42)
      acc95(36)=abb95(44)
      acc95(37)=abb95(45)
      acc95(38)=abb95(46)
      acc95(39)=abb95(47)
      acc95(40)=abb95(48)
      acc95(41)=abb95(49)
      acc95(42)=acc95(14)*Qspe2
      acc95(43)=-acc95(22)*Qspe3
      acc95(44)=-acc95(28)*Qspvak5e3
      acc95(45)=-acc95(30)*Qspvak5e2
      acc95(46)=acc95(32)*Qspvae2k4
      acc95(47)=acc95(33)*Qspvae3k4
      acc95(48)=-acc95(34)*Qspvak4e2
      acc95(49)=-acc95(35)*Qspvak4e3
      acc95(50)=acc95(40)*Qspvae3k1
      acc95(51)=acc95(41)*Qspvae2k1
      acc95(42)=acc95(42)+acc95(43)+acc95(51)+acc95(50)+acc95(49)+acc95(48)+acc&
      &95(47)+acc95(46)+acc95(45)+acc95(44)
      acc95(43)=mu2-QspQ
      acc95(42)=acc95(43)*acc95(42)
      acc95(43)=acc95(9)*Qspvak5e3
      acc95(44)=acc95(11)*Qspe3
      acc95(45)=acc95(12)*Qspvak4e3
      acc95(46)=acc95(13)*Qspvak3k1
      acc95(47)=acc95(16)*Qspvak3k4
      acc95(48)=acc95(18)*Qspvak5k3
      acc95(49)=acc95(19)*Qspk3
      acc95(50)=acc95(20)*Qspvak4k3
      acc95(51)=acc95(31)*Qspvae3k4
      acc95(52)=acc95(39)*Qspvae3k1
      acc95(43)=acc95(52)+acc95(51)+acc95(50)+acc95(49)+acc95(48)+acc95(47)+acc&
      &95(46)+acc95(45)+acc95(44)+acc95(43)+acc95(5)
      acc95(43)=Qspe2*acc95(43)
      acc95(44)=acc95(10)*Qspvae2k1
      acc95(45)=acc95(17)*Qspvak4k2
      acc95(46)=acc95(21)*Qspvak2k1
      acc95(47)=acc95(24)*Qspvak2k4
      acc95(48)=acc95(25)*Qspvak5k2
      acc95(49)=acc95(26)*Qspk2
      acc95(50)=acc95(29)*Qspvak5e2
      acc95(51)=acc95(36)*Qspvae2k4
      acc95(52)=acc95(38)*Qspvak4e2
      acc95(44)=acc95(52)+acc95(51)+acc95(50)+acc95(49)+acc95(48)+acc95(47)+acc&
      &95(46)+acc95(45)+acc95(44)+acc95(7)
      acc95(44)=Qspe3*acc95(44)
      acc95(45)=acc95(1)*Qspvak4k2
      acc95(46)=acc95(2)*Qspvak3k4
      acc95(47)=acc95(3)*Qspvak3k1
      acc95(48)=acc95(4)*Qspvak5k3
      acc95(49)=acc95(6)*Qspvak2k1
      acc95(50)=acc95(8)*Qspvak5k2
      acc95(51)=acc95(15)*Qspk3
      acc95(52)=acc95(23)*Qspk2
      acc95(53)=acc95(27)*Qspvak2k4
      acc95(54)=acc95(37)*Qspvak4k3
      brack=acc95(42)+acc95(43)+acc95(44)+acc95(45)+acc95(46)+acc95(47)+acc95(4&
      &8)+acc95(49)+acc95(50)+acc95(51)+acc95(52)+acc95(53)+acc95(54)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram95_sign, shift => diagram95_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd95h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d95
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(+Q_ext(4),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d95 = 0.0_ki
      d95 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d95, ki), aimag(d95), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd95h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d95
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(+Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d95 = 0.0_ki
      d95 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d95, ki), aimag(d95), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d95h0l1
