module     dgaad_d159h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d159h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd159h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc159(84)
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspe2
      complex(ki) :: Qspe3
      complex(ki) :: Qspk5
      complex(ki) :: Qspvae3k5
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspvak1k5
      complex(ki) :: QspQ
      complex(ki) :: Qspvae2k5
      complex(ki) :: Qspk4
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspk2
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspe4 = dotproduct(Q,e4)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspe2 = dotproduct(Q,e2)
      Qspe3 = dotproduct(Q,e3)
      Qspk5 = dotproduct(Q,k5)
      Qspvae3k5 = dotproduct(Q,spvae3k5)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      QspQ = dotproduct(Q,Q)
      Qspvae2k5 = dotproduct(Q,spvae2k5)
      Qspk4 = dotproduct(Q,k4)
      Qspk1 = dotproduct(Q,k1)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspk2 = dotproduct(Q,k2)
      acc159(1)=abb159(2)
      acc159(2)=abb159(3)
      acc159(3)=abb159(4)
      acc159(4)=abb159(5)
      acc159(5)=abb159(6)
      acc159(6)=abb159(7)
      acc159(7)=abb159(8)
      acc159(8)=abb159(9)
      acc159(9)=abb159(10)
      acc159(10)=abb159(11)
      acc159(11)=abb159(12)
      acc159(12)=abb159(13)
      acc159(13)=abb159(14)
      acc159(14)=abb159(15)
      acc159(15)=abb159(16)
      acc159(16)=abb159(17)
      acc159(17)=abb159(18)
      acc159(18)=abb159(19)
      acc159(19)=abb159(20)
      acc159(20)=abb159(21)
      acc159(21)=abb159(22)
      acc159(22)=abb159(23)
      acc159(23)=abb159(24)
      acc159(24)=abb159(25)
      acc159(25)=abb159(26)
      acc159(26)=abb159(27)
      acc159(27)=abb159(28)
      acc159(28)=abb159(29)
      acc159(29)=abb159(30)
      acc159(30)=abb159(31)
      acc159(31)=abb159(32)
      acc159(32)=abb159(33)
      acc159(33)=abb159(34)
      acc159(34)=abb159(35)
      acc159(35)=abb159(36)
      acc159(36)=abb159(37)
      acc159(37)=abb159(38)
      acc159(38)=abb159(39)
      acc159(39)=abb159(40)
      acc159(40)=abb159(41)
      acc159(41)=abb159(42)
      acc159(42)=abb159(43)
      acc159(43)=abb159(44)
      acc159(44)=abb159(45)
      acc159(45)=abb159(46)
      acc159(46)=abb159(47)
      acc159(47)=abb159(48)
      acc159(48)=abb159(49)
      acc159(49)=abb159(50)
      acc159(50)=abb159(51)
      acc159(51)=abb159(52)
      acc159(52)=abb159(53)
      acc159(53)=abb159(54)
      acc159(54)=abb159(55)
      acc159(55)=abb159(56)
      acc159(56)=abb159(58)
      acc159(57)=abb159(60)
      acc159(58)=abb159(63)
      acc159(59)=abb159(64)
      acc159(60)=abb159(65)
      acc159(61)=abb159(66)
      acc159(62)=abb159(67)
      acc159(63)=abb159(69)
      acc159(64)=abb159(71)
      acc159(65)=abb159(72)
      acc159(66)=abb159(73)
      acc159(67)=abb159(74)
      acc159(68)=Qspvak1e2*Qspe4
      acc159(69)=acc159(16)*acc159(68)
      acc159(70)=acc159(20)*Qspvak1e2
      acc159(71)=acc159(25)*Qspvak1k4
      acc159(72)=acc159(26)*Qspe2
      acc159(73)=Qspe2*Qspe3
      acc159(74)=acc159(30)*acc159(73)
      acc159(75)=acc159(33)*Qspk5
      acc159(76)=acc159(38)*Qspvae3k5
      acc159(77)=acc159(44)*Qspvak1e4
      acc159(78)=Qspvae3k5*Qspe4
      acc159(79)=acc159(45)*acc159(78)
      acc159(80)=Qspvak1e3*Qspe4
      acc159(81)=acc159(62)*acc159(80)
      acc159(82)=acc159(63)*Qspvak1k5
      acc159(69)=acc159(82)+acc159(81)+acc159(79)+acc159(77)+acc159(76)+acc159(&
      &75)+acc159(74)+acc159(72)+acc159(71)+acc159(24)+acc159(70)+acc159(69)
      acc159(69)=QspQ*acc159(69)
      acc159(70)=acc159(64)*Qspe3
      acc159(70)=acc159(70)+acc159(55)
      acc159(70)=Qspvak1e2*acc159(70)
      acc159(71)=acc159(18)*Qspvae2k5*Qspe3
      acc159(72)=acc159(19)*Qspk5
      acc159(74)=acc159(39)*Qspvae3k5
      acc159(75)=acc159(47)*Qspvak1k5
      acc159(76)=acc159(56)*Qspvak1e4
      acc159(77)=Qspvak1e4*Qspe3
      acc159(79)=acc159(58)*acc159(77)
      acc159(70)=acc159(79)+acc159(76)+acc159(75)+acc159(74)+acc159(72)+acc159(&
      &71)+acc159(70)
      acc159(70)=Qspk4*acc159(70)
      acc159(71)=acc159(3)*Qspe3
      acc159(71)=acc159(10)+acc159(71)
      acc159(71)=Qspvak1k5*acc159(71)
      acc159(72)=-Qspk1-Qspk5
      acc159(72)=acc159(15)*acc159(72)
      acc159(74)=acc159(11)*Qspvak1k2
      acc159(75)=acc159(12)*Qspvak1k4
      acc159(76)=acc159(37)*Qspvae3k5
      acc159(79)=acc159(60)*Qspvak1e3
      acc159(71)=acc159(79)+acc159(76)+acc159(75)+acc159(74)+acc159(72)+acc159(&
      &71)
      acc159(71)=acc159(71)*Qspe2
      acc159(72)=acc159(48)*Qspvak1k2
      acc159(71)=acc159(72)+acc159(71)
      acc159(71)=Qspe4*acc159(71)
      acc159(72)=acc159(23)*Qspvak1k4
      acc159(74)=acc159(40)*Qspvak2k5
      acc159(75)=acc159(46)*Qspvae2k5
      acc159(76)=acc159(51)*Qspvak1k2
      acc159(79)=acc159(59)*Qspvak1e2
      acc159(81)=acc159(67)*Qspvak4k5
      acc159(72)=acc159(81)+acc159(79)+acc159(76)+acc159(75)+acc159(74)+acc159(&
      &72)
      acc159(72)=acc159(72)*Qspe4
      acc159(74)=acc159(42)*Qspvak2k5
      acc159(75)=acc159(66)*Qspvak4k5
      acc159(72)=acc159(75)+acc159(74)+acc159(72)
      acc159(72)=Qspe3*acc159(72)
      acc159(74)=-acc159(17)*acc159(68)
      acc159(75)=acc159(28)*Qspvak1k4
      acc159(76)=acc159(35)*QspQ
      acc159(79)=acc159(41)*acc159(78)
      acc159(80)=acc159(61)*acc159(80)
      acc159(74)=acc159(80)+acc159(79)+acc159(76)+acc159(75)+acc159(74)
      acc159(75)=Qspk2-Qspk4
      acc159(74)=acc159(75)*acc159(74)
      acc159(75)=acc159(4)*Qspe4
      acc159(76)=acc159(21)*Qspe3
      acc159(79)=acc159(29)*acc159(73)
      acc159(80)=acc159(36)*Qspe2
      acc159(75)=acc159(80)+acc159(79)+acc159(76)+acc159(75)+acc159(1)
      acc159(75)=Qspvak1k4*acc159(75)
      acc159(76)=acc159(5)*Qspk2
      acc159(79)=acc159(53)*Qspe2
      acc159(80)=acc159(54)*acc159(73)
      acc159(81)=QspQ*Qspe3
      acc159(82)=acc159(57)*acc159(81)
      acc159(76)=acc159(82)+acc159(80)+acc159(79)+acc159(49)+acc159(76)
      acc159(76)=Qspvak1e4*acc159(76)
      acc159(79)=acc159(31)*Qspe2
      acc159(80)=acc159(43)*Qspk2
      acc159(79)=acc159(80)+acc159(79)
      acc159(79)=Qspvae3k5*acc159(79)
      acc159(80)=acc159(7)*Qspe4
      acc159(82)=acc159(8)*Qspe2
      acc159(80)=acc159(82)+acc159(80)+acc159(2)
      acc159(80)=Qspvak1k5*acc159(80)
      acc159(82)=acc159(9)*Qspe4
      acc159(83)=acc159(14)*Qspe2
      acc159(82)=acc159(83)+acc159(82)+acc159(6)
      acc159(82)=Qspk5*acc159(82)
      acc159(83)=-acc159(32)*Qspvae2k5
      acc159(84)=acc159(65)*Qspvak1e2
      acc159(83)=acc159(84)+acc159(83)+acc159(27)
      acc159(81)=acc159(81)*acc159(83)
      acc159(73)=acc159(13)*Qspvak4k5*acc159(73)
      acc159(78)=acc159(22)*acc159(78)
      acc159(83)=acc159(34)*QspQ**2
      acc159(77)=acc159(50)*acc159(77)
      acc159(68)=acc159(52)*acc159(68)
      brack=acc159(68)+acc159(69)+acc159(70)+acc159(71)+acc159(72)+acc159(73)+a&
      &cc159(74)+acc159(75)+acc159(76)+acc159(77)+acc159(78)+acc159(79)+acc159(&
      &80)+acc159(81)+acc159(82)+acc159(83)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram159_sign, shift => diagram159_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd159h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d159
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2-k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d159 = 0.0_ki
      d159 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d159, ki), aimag(d159), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd159h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d159
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2-k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d159 = 0.0_ki
      d159 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d159, ki), aimag(d159), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d159h8l1
