module     dgaad_d21h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d21h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd21h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc21(34)
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae4k5
      complex(ki) :: Qspk4
      complex(ki) :: QspQ
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3k5
      complex(ki) :: Qspvak3k5
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspe2 = dotproduct(Q,e2)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspe4 = dotproduct(Q,e4)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      Qspk4 = dotproduct(Q,k4)
      QspQ = dotproduct(Q,Q)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3k5 = dotproduct(Q,spvae3k5)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      acc21(1)=abb21(3)
      acc21(2)=abb21(4)
      acc21(3)=abb21(5)
      acc21(4)=abb21(6)
      acc21(5)=abb21(7)
      acc21(6)=abb21(8)
      acc21(7)=abb21(9)
      acc21(8)=abb21(10)
      acc21(9)=abb21(11)
      acc21(10)=abb21(12)
      acc21(11)=abb21(14)
      acc21(12)=abb21(15)
      acc21(13)=abb21(16)
      acc21(14)=abb21(17)
      acc21(15)=abb21(18)
      acc21(16)=abb21(21)
      acc21(17)=abb21(23)
      acc21(18)=abb21(25)
      acc21(19)=abb21(26)
      acc21(20)=abb21(27)
      acc21(21)=abb21(29)
      acc21(22)=abb21(30)
      acc21(23)=abb21(31)
      acc21(24)=abb21(32)
      acc21(25)=abb21(33)
      acc21(26)=abb21(37)
      acc21(27)=Qspk2+Qspk1
      acc21(28)=acc21(25)*acc21(27)
      acc21(29)=-acc21(7)*Qspvak2k5
      acc21(30)=Qspe2*acc21(17)
      acc21(31)=Qspvak1e2*acc21(3)
      acc21(28)=acc21(31)+acc21(30)+acc21(8)+acc21(29)+acc21(28)
      acc21(28)=Qspe4*acc21(28)
      acc21(29)=acc21(22)*acc21(27)
      acc21(30)=acc21(23)*Qspvae4k5
      acc21(31)=Qspk4*acc21(20)
      acc21(32)=Qspe2*acc21(14)
      acc21(33)=Qspvak1e2*acc21(15)
      acc21(34)=QspQ*acc21(19)
      acc21(28)=acc21(28)+acc21(34)+acc21(33)+acc21(32)+acc21(30)+acc21(31)+acc&
      &21(29)
      acc21(28)=Qspe3*acc21(28)
      acc21(29)=-acc21(10)*acc21(27)
      acc21(30)=acc21(26)*Qspvae3k5
      acc21(31)=Qspe2*acc21(9)
      acc21(32)=Qspvak1e2*acc21(2)
      acc21(29)=acc21(32)+acc21(31)+acc21(30)+acc21(18)+acc21(29)
      acc21(29)=QspQ*acc21(29)
      acc21(30)=-acc21(24)*acc21(27)
      acc21(31)=Qspvak3k5*acc21(1)
      acc21(32)=Qspe2*acc21(16)
      acc21(33)=Qspvak1e2*acc21(12)
      acc21(30)=acc21(33)+acc21(32)+acc21(5)+acc21(31)+acc21(30)
      acc21(30)=Qspe4*acc21(30)
      acc21(27)=acc21(21)*acc21(27)
      acc21(31)=Qspk4*acc21(4)
      acc21(32)=Qspvak3k5*acc21(6)
      acc21(33)=Qspe2*acc21(13)
      acc21(34)=Qspvak1e2*acc21(11)
      brack=acc21(27)+acc21(28)+acc21(29)+acc21(30)+acc21(31)+acc21(32)+acc21(3&
      &3)+acc21(34)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram21_sign, shift => diagram21_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd21h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d21
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k5
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d21 = 0.0_ki
      d21 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d21, ki), aimag(d21), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd21h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d21
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k5
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d21 = 0.0_ki
      d21 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d21, ki), aimag(d21), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d21h8l1
