module     dgaad_d59h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d59h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd59h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc59(38)
      complex(ki) :: Qspvae4k2
      complex(ki) :: Qspvae4k5
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspvak3k2
      complex(ki) :: Qspvak4k2
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspe4
      complex(ki) :: QspQ
      complex(ki) :: Qspk3
      Qspvae4k2 = dotproduct(Q,spvae4k2)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      Qspvak4k2 = dotproduct(Q,spvak4k2)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspe3 = dotproduct(Q,e3)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspe4 = dotproduct(Q,e4)
      QspQ = dotproduct(Q,Q)
      Qspk3 = dotproduct(Q,k3)
      acc59(1)=abb59(3)
      acc59(2)=abb59(4)
      acc59(3)=abb59(5)
      acc59(4)=abb59(6)
      acc59(5)=abb59(7)
      acc59(6)=abb59(8)
      acc59(7)=abb59(9)
      acc59(8)=abb59(10)
      acc59(9)=abb59(11)
      acc59(10)=abb59(12)
      acc59(11)=abb59(13)
      acc59(12)=abb59(14)
      acc59(13)=abb59(15)
      acc59(14)=abb59(16)
      acc59(15)=abb59(17)
      acc59(16)=abb59(18)
      acc59(17)=abb59(19)
      acc59(18)=abb59(20)
      acc59(19)=abb59(21)
      acc59(20)=abb59(23)
      acc59(21)=abb59(24)
      acc59(22)=abb59(25)
      acc59(23)=abb59(26)
      acc59(24)=abb59(27)
      acc59(25)=abb59(28)
      acc59(26)=abb59(29)
      acc59(27)=abb59(30)
      acc59(28)=abb59(31)
      acc59(29)=abb59(32)
      acc59(30)=acc59(8)*Qspvae4k2
      acc59(31)=acc59(9)*Qspvae4k5
      acc59(32)=acc59(14)*Qspvak1e4
      acc59(33)=acc59(18)*Qspvak1k3
      acc59(34)=acc59(24)*Qspvak3k2
      acc59(35)=acc59(25)*Qspvak4k2
      acc59(36)=acc59(26)*Qspvak4k5
      acc59(37)=acc59(28)*Qspvak3k5
      acc59(38)=Qspvak1k4*acc59(29)
      acc59(30)=acc59(38)+acc59(37)+acc59(36)+acc59(35)+acc59(34)+acc59(33)+acc&
      &59(32)+acc59(31)+acc59(30)
      acc59(30)=Qspe3*acc59(30)
      acc59(31)=Qspvak1k5*acc59(3)
      acc59(32)=Qspvak1k2*acc59(1)
      acc59(31)=acc59(32)+acc59(31)
      acc59(31)=acc59(31)*Qspe3
      acc59(32)=acc59(6)*Qspvak1k3
      acc59(33)=acc59(15)*Qspvak1e3
      acc59(34)=acc59(22)*Qspvak3k2
      acc59(35)=acc59(27)*Qspvak3k5
      acc59(31)=acc59(31)+acc59(35)+acc59(34)+acc59(33)+acc59(32)
      acc59(31)=Qspe4*acc59(31)
      acc59(32)=acc59(4)*Qspvak1e4
      acc59(33)=acc59(7)*Qspe4
      acc59(34)=acc59(10)*Qspvae4k2
      acc59(35)=acc59(13)*Qspvae4k5
      acc59(36)=acc59(20)*Qspvak1e3
      acc59(32)=acc59(36)+acc59(35)+acc59(34)+acc59(33)+acc59(5)+acc59(32)
      acc59(32)=QspQ*acc59(32)
      acc59(33)=acc59(11)*Qspvae4k2
      acc59(34)=acc59(12)*Qspvae4k5
      acc59(35)=acc59(16)*Qspvak1e4
      acc59(36)=acc59(21)*Qspvak1e3
      acc59(33)=acc59(36)+acc59(35)+acc59(34)+acc59(33)
      acc59(33)=Qspk3*acc59(33)
      acc59(34)=acc59(2)*Qspvak1k3
      acc59(35)=acc59(17)*Qspvak4k2
      acc59(36)=acc59(19)*Qspvak1e3
      acc59(37)=acc59(23)*Qspvak4k5
      brack=acc59(30)+acc59(31)+acc59(32)+acc59(33)+acc59(34)+acc59(35)+acc59(3&
      &6)+acc59(37)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram59_sign, shift => diagram59_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd59h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d59
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d59 = 0.0_ki
      d59 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d59, ki), aimag(d59), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd59h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d59
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d59 = 0.0_ki
      d59 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d59, ki), aimag(d59), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d59h8l1
