module     ugaau_scalar_cache
   use precision, only: ki_sam => ki
   use madds
   implicit none
   save

   private
!---#[ scalar integral cache for samurai:
    logical, public  :: samurai_cache_flag_g0
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g0
    logical, public :: samurai_cache_flag_d6
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d6
    logical, public :: samurai_cache_flag_d16
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d16
    logical, public :: samurai_cache_flag_d26
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d26
    logical, public :: samurai_cache_flag_d60
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d60
    logical, public :: samurai_cache_flag_d125
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d125
    logical, public :: samurai_cache_flag_d160
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d160
    logical, public  :: samurai_cache_flag_g1
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g1
    logical, public :: samurai_cache_flag_d7
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d7
    logical, public :: samurai_cache_flag_d9
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d9
    logical, public :: samurai_cache_flag_d27
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d27
    logical, public :: samurai_cache_flag_d63
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d63
    logical, public :: samurai_cache_flag_d68
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d68
    logical, public :: samurai_cache_flag_d159
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d159
    logical, public  :: samurai_cache_flag_g2
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g2
    logical, public :: samurai_cache_flag_d24
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d24
    logical, public :: samurai_cache_flag_d29
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d29
    logical, public :: samurai_cache_flag_d66
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d66
    logical, public :: samurai_cache_flag_d82
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d82
    logical, public :: samurai_cache_flag_d95
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d95
    logical, public :: samurai_cache_flag_d157
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d157
    logical, public  :: samurai_cache_flag_g3
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g3
    logical, public :: samurai_cache_flag_d39
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d39
    logical, public :: samurai_cache_flag_d65
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d65
    logical, public :: samurai_cache_flag_d155
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d155
    logical, public  :: samurai_cache_flag_g4
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g4
    logical, public :: samurai_cache_flag_d23
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d23
    logical, public :: samurai_cache_flag_d158
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d158
    logical, public  :: samurai_cache_flag_g5
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g5
    logical, public :: samurai_cache_flag_d49
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d49
    logical, public :: samurai_cache_flag_d62
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d62
    logical, public :: samurai_cache_flag_d156
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d156
    logical, public  :: samurai_cache_flag_g6
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g6
    logical, public :: samurai_cache_flag_d1
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d1
    logical, public :: samurai_cache_flag_d21
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d21
    logical, public :: samurai_cache_flag_d28
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d28
    logical, public :: samurai_cache_flag_d61
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d61
    logical, public :: samurai_cache_flag_d154
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d154
    logical, public  :: samurai_cache_flag_g7
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_g7
    logical, public :: samurai_cache_flag_d2
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d2
    logical, public :: samurai_cache_flag_d3
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d3
    logical, public :: samurai_cache_flag_d4
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d4
    logical, public :: samurai_cache_flag_d10
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d10
    logical, public :: samurai_cache_flag_d11
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d11
    logical, public :: samurai_cache_flag_d15
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d15
    logical, public :: samurai_cache_flag_d17
    complex(ki_sam), dimension(-2:0,cachedim2(1)), public :: samurai_cache_d17
    logical, public :: samurai_cache_flag_d22
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d22
    logical, public :: samurai_cache_flag_d25
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d25
    logical, public :: samurai_cache_flag_d59
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d59
    logical, public :: samurai_cache_flag_d64
    complex(ki_sam), dimension(-2:0,cachedim4(1)), public :: samurai_cache_d64
    logical, public :: samurai_cache_flag_d67
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d67
    logical, public :: samurai_cache_flag_d80
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d80
    logical, public :: samurai_cache_flag_d126
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d126
    logical, public :: samurai_cache_flag_d138
    complex(ki_sam), dimension(-2:0,cachedim3(1)), public :: samurai_cache_d138
    logical, public :: samurai_cache_flag_d153
    complex(ki_sam), dimension(-2:0,cachedim5(1)), public :: samurai_cache_d153
!---#] scalar integral cache for samurai:

   public :: invalidate_cache
contains
   subroutine invalidate_cache()
      implicit none
      samurai_cache_flag_g0 = .false.
      samurai_cache_flag_d6 = .false.
      samurai_cache_flag_d16 = .false.
      samurai_cache_flag_d26 = .false.
      samurai_cache_flag_d60 = .false.
      samurai_cache_flag_d125 = .false.
      samurai_cache_flag_d160 = .false.
      samurai_cache_flag_g1 = .false.
      samurai_cache_flag_d7 = .false.
      samurai_cache_flag_d9 = .false.
      samurai_cache_flag_d27 = .false.
      samurai_cache_flag_d63 = .false.
      samurai_cache_flag_d68 = .false.
      samurai_cache_flag_d159 = .false.
      samurai_cache_flag_g2 = .false.
      samurai_cache_flag_d24 = .false.
      samurai_cache_flag_d29 = .false.
      samurai_cache_flag_d66 = .false.
      samurai_cache_flag_d82 = .false.
      samurai_cache_flag_d95 = .false.
      samurai_cache_flag_d157 = .false.
      samurai_cache_flag_g3 = .false.
      samurai_cache_flag_d39 = .false.
      samurai_cache_flag_d65 = .false.
      samurai_cache_flag_d155 = .false.
      samurai_cache_flag_g4 = .false.
      samurai_cache_flag_d23 = .false.
      samurai_cache_flag_d158 = .false.
      samurai_cache_flag_g5 = .false.
      samurai_cache_flag_d49 = .false.
      samurai_cache_flag_d62 = .false.
      samurai_cache_flag_d156 = .false.
      samurai_cache_flag_g6 = .false.
      samurai_cache_flag_d1 = .false.
      samurai_cache_flag_d21 = .false.
      samurai_cache_flag_d28 = .false.
      samurai_cache_flag_d61 = .false.
      samurai_cache_flag_d154 = .false.
      samurai_cache_flag_g7 = .false.
      samurai_cache_flag_d2 = .false.
      samurai_cache_flag_d3 = .false.
      samurai_cache_flag_d4 = .false.
      samurai_cache_flag_d10 = .false.
      samurai_cache_flag_d11 = .false.
      samurai_cache_flag_d15 = .false.
      samurai_cache_flag_d17 = .false.
      samurai_cache_flag_d22 = .false.
      samurai_cache_flag_d25 = .false.
      samurai_cache_flag_d59 = .false.
      samurai_cache_flag_d64 = .false.
      samurai_cache_flag_d67 = .false.
      samurai_cache_flag_d80 = .false.
      samurai_cache_flag_d126 = .false.
      samurai_cache_flag_d138 = .false.
      samurai_cache_flag_d153 = .false.
   end subroutine invalidate_cache
end module ugaau_scalar_cache