#!/usr/bin/python
# -*- coding: utf-8 -*-
import math
import subprocess
# First, get the last line of bestres.dat
bestfile=file('bestres.dat')
prevruns=open('prevruns.dat',"a")
while True:
  line=bestfile.readline()
  if len(line)==0:
    break
  parts=line.split()
  bestmean=float(parts[0])
  besterr=float(parts[1])
  proc=parts[2]
# Then get the right entry out of sumresults.dat
sumfile=file('../sumresults.dat')
while True:
  line=sumfile.readline()
  if len(line)==0:
    break
  if line.find(proc)>0:
    prevruns.write(line+'\n')
    parts=line.split()
    mean=float(parts[0])
    err=float(parts[1])
    break
#Now combine the two results by using weighted averages.
if besterr>0:
  wbest=1.0/besterr**2
else:
  wbest=0.0
if err>0:
  werr=1.0/err**2
else:
  werr=0.0
wsum=wbest+werr
newmean=wbest*bestmean+werr*mean
newmean=newmean/wsum
dbest=bestmean-newmean
d1=mean-newmean
newerr=wbest*dbest**2+werr*d1**2
newerr=newerr/wsum
newerr=math.sqrt(newerr)
#Put the new result into sumresults.dat
sumfile.seek(0)
sumfiletemp=open('../sumresultstemp.dat',"w")
while True:
  line=sumfile.readline()
  if len(line)==0:
    break
  if line.find(proc)>0:
    parts=line.split()
    line1=line.replace(parts[0],str(newmean))
    line1=line1.replace(parts[1],str(newerr))
    sumfiletemp.write(line1)
  else:
    sumfiletemp.write(line)
sumfiletemp.close()
prevruns.close()
subprocess.Popen("mv ../sumresultstemp.dat ../sumresults.dat",shell=True)