      double precision function pdg2pdf(ih,ipdg,x,xmu)
c***************************************************************************
c     Based on pdf.f, wrapper for calling the pdf of MCFM
c***************************************************************************
      implicit none
c
c     Arguments
c
      DOUBLE  PRECISION x,xmu
      INTEGER IH,ipdg,ipart
C
C     Include
C
      include 'pdf.inc'
C      
      double precision Ctq3df,Ctq4Fn,Ctq5Pdf,Ctq6Pdf,Ctq5L
      integer mode,Irt,ihlast
      double precision xlast,xmulast,pdflast(-7:7),q2max,f(-6:6)
      double precision epa_electron,epa_proton
      save ihlast,xlast,xmulast,pdflast

      ipart=ipdg
      if(iabs(ipart).eq.21) ipart=0
      if(iabs(ipart).eq.22) ipart=7

      call evolvePDF(x,xmu,f)
      pdg2pdf=f(ipart)/x


      end

