#!/usr/bin/python
# -*- coding: utf-8 -*-
import os
import os.path
import sys

plotfile=file('plotlist.txt')
procfile=file(sys.argv[1])
plotlist={}
i=0
while True:
  line=plotfile.readline()
  if len(line)==0:
    break
  plotlist[i]=line.split('\n')[0]
  i +=1
for j in range(0,i):
  plotfile_new=open(plotlist[j]+'all.dat',"w")
  sumbin={}
  sumvalue={}
  sumerr={}
  firsttime=True
  procfile.seek(0)
  while True:
    line=procfile.readline()
    if len(line)==0:
      break
    proc=line.split('\n')[0]
# Check if plot exists
    if not os.path.isfile(proc+'/'+plotlist[j]+'.dat1'):
      print 'Warning: Plot '+proc+'/'+plotlist[j]+'.dat1 does not exist'
# Use the first process to check the number of entries
# and set initial values to zero
    else:
      if firsttime:
	firsttime=False
	curplot=file(proc+'/'+plotlist[j]+'.dat1')
	nbins=0
	while True:
	  line1=curplot.readline()
	  if len(line1)==0:
	    break
	  nbins +=1
	for k in range(0,nbins):
	  sumbin[k]=0.0
	  sumvalue[k]=0.0
	  sumerr[k]=0.0
      curplot=file(proc+'/'+plotlist[j]+'.dat1')
# Summing things up
      l=0
      while True:
	plotline=curplot.readline()
	if len(plotline)==0:
	  break
	parts=plotline.split()
	sumbin[l] = parts[0]
	sumvalue[l] += float(parts[1])
	sumerr[l] +=  float(parts[2])
	l +=1
  for m in range(0,l):
    plotfile_new.write(sumbin[m]+'  '+str("%.15e" % sumvalue[m])+'  '+str("%.15e" % sumerr[m])+'\n')
  plotfile_new.close()

# copying the files into the result directory  
if sys.argv[1]=='proclist.txt':
  if not os.listdir('../../results/tree_level'):
    os.system('./copyresults')
  else:
    print 'Results in /results/tree_level already exist. Overwrite (y/n) ?'
    overwrite=raw_input()
    if overwrite.lower()=='y':
      os.system('rm -r ../../results/tree_level/* ')
      os.system('./copyresults')
    else:
      sys.exit()
elif sys.argv[1]=='proclist_virt.txt':
  if not os.listdir('../../results/virt'):
    os.system('./copyresults_virt')
  else:
    print 'Results in /results/virt already exist. Overwrite (y/n) ?'
    overwrite=raw_input()
    if overwrite.lower()=='y':
      os.system('rm -r ../../results/virt/* ')      
      os.system('./copyresults_virt')
    else:
      sys.exit()
    
