module     dgaad_d49h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d49h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd49h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc49(101)
      complex(ki) :: Qspk4
      complex(ki) :: QspQ
      complex(ki) :: Qspk2
      complex(ki) :: Qspk3
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspe3
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspe2
      Qspk4 = dotproduct(Q,k4)
      QspQ = dotproduct(Q,Q)
      Qspk2 = dotproduct(Q,k2)
      Qspk3 = dotproduct(Q,k3)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspe3 = dotproduct(Q,e3)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspe2 = dotproduct(Q,e2)
      acc49(1)=abb49(2)
      acc49(2)=abb49(3)
      acc49(3)=abb49(4)
      acc49(4)=abb49(5)
      acc49(5)=abb49(6)
      acc49(6)=abb49(7)
      acc49(7)=abb49(8)
      acc49(8)=abb49(9)
      acc49(9)=abb49(10)
      acc49(10)=abb49(11)
      acc49(11)=abb49(12)
      acc49(12)=abb49(13)
      acc49(13)=abb49(14)
      acc49(14)=abb49(15)
      acc49(15)=abb49(16)
      acc49(16)=abb49(17)
      acc49(17)=abb49(18)
      acc49(18)=abb49(19)
      acc49(19)=abb49(20)
      acc49(20)=abb49(21)
      acc49(21)=abb49(22)
      acc49(22)=abb49(23)
      acc49(23)=abb49(24)
      acc49(24)=abb49(25)
      acc49(25)=abb49(26)
      acc49(26)=abb49(27)
      acc49(27)=abb49(28)
      acc49(28)=abb49(29)
      acc49(29)=abb49(30)
      acc49(30)=abb49(31)
      acc49(31)=abb49(32)
      acc49(32)=abb49(33)
      acc49(33)=abb49(34)
      acc49(34)=abb49(35)
      acc49(35)=abb49(36)
      acc49(36)=abb49(37)
      acc49(37)=abb49(38)
      acc49(38)=abb49(39)
      acc49(39)=abb49(40)
      acc49(40)=abb49(41)
      acc49(41)=abb49(42)
      acc49(42)=abb49(43)
      acc49(43)=abb49(44)
      acc49(44)=abb49(45)
      acc49(45)=abb49(46)
      acc49(46)=abb49(47)
      acc49(47)=abb49(48)
      acc49(48)=abb49(49)
      acc49(49)=abb49(50)
      acc49(50)=abb49(51)
      acc49(51)=abb49(52)
      acc49(52)=abb49(53)
      acc49(53)=abb49(54)
      acc49(54)=abb49(55)
      acc49(55)=abb49(56)
      acc49(56)=abb49(57)
      acc49(57)=abb49(58)
      acc49(58)=abb49(59)
      acc49(59)=abb49(60)
      acc49(60)=abb49(61)
      acc49(61)=abb49(62)
      acc49(62)=abb49(63)
      acc49(63)=abb49(64)
      acc49(64)=abb49(65)
      acc49(65)=abb49(66)
      acc49(66)=abb49(67)
      acc49(67)=abb49(68)
      acc49(68)=abb49(69)
      acc49(69)=abb49(70)
      acc49(70)=abb49(71)
      acc49(71)=abb49(72)
      acc49(72)=abb49(73)
      acc49(73)=abb49(74)
      acc49(74)=abb49(76)
      acc49(75)=abb49(77)
      acc49(76)=abb49(78)
      acc49(77)=abb49(79)
      acc49(78)=abb49(82)
      acc49(79)=abb49(83)
      acc49(80)=abb49(84)
      acc49(81)=abb49(85)
      acc49(82)=abb49(86)
      acc49(83)=abb49(87)
      acc49(84)=abb49(88)
      acc49(85)=abb49(89)
      acc49(86)=abb49(90)
      acc49(87)=-Qspk4+mu2
      acc49(87)=acc49(75)*acc49(87)
      acc49(88)=-QspQ-Qspk2-Qspk3
      acc49(88)=acc49(69)*acc49(88)
      acc49(89)=Qspvae2k1*acc49(43)
      acc49(90)=Qspvak5e2*acc49(39)
      acc49(91)=Qspvak3k1*acc49(49)
      acc49(92)=Qspvak4k1*acc49(86)
      acc49(93)=Qspvak5k3*acc49(74)
      acc49(94)=Qspvak5k4*acc49(84)
      acc49(95)=Qspvak2k1*acc49(37)
      acc49(96)=Qspvak5k2*acc49(41)
      acc49(97)=Qspvae3k1*acc49(63)
      acc49(98)=Qspvak5e3*acc49(61)
      acc49(87)=acc49(98)+acc49(97)+acc49(96)+acc49(95)+acc49(94)+acc49(93)+acc&
      &49(92)+acc49(91)+acc49(90)+acc49(40)+acc49(89)+acc49(88)+acc49(87)
      acc49(87)=QspQ*acc49(87)
      acc49(88)=QspQ-mu2
      acc49(89)=acc49(67)*acc49(88)
      acc49(90)=Qspvae2k1*acc49(11)
      acc49(91)=Qspvak5e2*acc49(5)
      acc49(92)=Qspk2*acc49(72)
      acc49(93)=Qspvak2k1*acc49(66)
      acc49(94)=Qspvak5k2*acc49(51)
      acc49(89)=acc49(94)+acc49(93)+acc49(92)+acc49(91)+acc49(21)+acc49(90)+acc&
      &49(89)
      acc49(89)=Qspe3*acc49(89)
      acc49(90)=Qspk4+Qspk3
      acc49(91)=acc49(47)*acc49(90)
      acc49(92)=Qspvak3k1*acc49(45)
      acc49(93)=Qspvak4k1*acc49(9)
      acc49(94)=Qspvak5k3*acc49(48)
      acc49(95)=Qspvak5k4*acc49(82)
      acc49(96)=Qspk2*acc49(68)
      acc49(97)=Qspvak2k1*acc49(54)
      acc49(98)=Qspvak5k2*acc49(33)
      acc49(99)=Qspvae3k1*acc49(12)
      acc49(100)=Qspvak5e3*acc49(6)
      acc49(101)=QspQ*acc49(65)
      acc49(89)=acc49(89)+acc49(101)+acc49(100)+acc49(99)+acc49(98)+acc49(97)+a&
      &cc49(96)+acc49(95)+acc49(94)+acc49(93)+acc49(92)+acc49(7)+acc49(91)
      acc49(89)=Qspe4*acc49(89)
      acc49(90)=acc49(55)*acc49(90)
      acc49(88)=acc49(52)*acc49(88)
      acc49(91)=Qspvak3k1*acc49(35)
      acc49(92)=Qspvak4k1*acc49(34)
      acc49(93)=Qspvak5k3*acc49(46)
      acc49(94)=Qspvak5k4*acc49(32)
      acc49(95)=Qspvae3k1*acc49(10)
      acc49(96)=Qspvak5e3*acc49(26)
      acc49(97)=acc49(2)*Qspvak5k1
      acc49(97)=acc49(22)+acc49(97)
      acc49(97)=Qspe3*acc49(97)
      acc49(88)=acc49(97)+acc49(96)+acc49(95)+acc49(94)+acc49(93)+acc49(92)+acc&
      &49(91)+acc49(25)+acc49(88)+acc49(90)
      acc49(88)=Qspe4*acc49(88)
      acc49(90)=Qspvae3k1*acc49(53)
      acc49(91)=Qspvae4k1*acc49(56)
      acc49(92)=Qspvak5e3*acc49(50)
      acc49(93)=Qspvak5e4*acc49(57)
      acc49(90)=-acc49(90)+acc49(91)+acc49(92)-acc49(93)
      acc49(91)=mu2*acc49(90)
      acc49(92)=Qspvae3k1*acc49(81)
      acc49(93)=Qspvae4k1*acc49(79)
      acc49(94)=Qspvak5e3*acc49(77)
      acc49(95)=Qspvak5e4*acc49(76)
      acc49(92)=acc49(95)+acc49(94)+acc49(93)+acc49(24)+acc49(92)
      acc49(92)=Qspk4*acc49(92)
      acc49(90)=acc49(23)-acc49(90)
      acc49(90)=QspQ*acc49(90)
      acc49(93)=Qspvak4k1*acc49(85)
      acc49(94)=Qspvak5k4*acc49(83)
      acc49(95)=Qspvae4k1*acc49(31)
      acc49(96)=Qspvak5e4*acc49(29)
      acc49(93)=acc49(96)+acc49(95)+acc49(94)+acc49(16)+acc49(93)
      acc49(93)=Qspe3*acc49(93)
      acc49(94)=Qspk3*acc49(58)
      acc49(95)=Qspvak3k1*acc49(3)
      acc49(96)=Qspvak5k3*acc49(27)
      acc49(97)=Qspvae4k1*acc49(78)
      acc49(98)=Qspvak5e4*acc49(71)
      acc49(88)=acc49(88)+acc49(93)+acc49(90)+acc49(92)+acc49(91)+acc49(98)+acc&
      &49(97)+acc49(96)+acc49(95)+acc49(4)+acc49(94)
      acc49(88)=Qspe2*acc49(88)
      acc49(90)=Qspvae2k1*acc49(13)
      acc49(91)=Qspvak5e2*acc49(18)
      acc49(92)=Qspvae4k1*acc49(80)
      acc49(93)=Qspvak5e4*acc49(59)
      acc49(90)=-acc49(90)+acc49(91)+acc49(92)-acc49(93)
      acc49(91)=mu2*acc49(90)
      acc49(90)=acc49(60)-acc49(90)
      acc49(90)=QspQ*acc49(90)
      acc49(92)=Qspvak4k1*acc49(20)
      acc49(93)=Qspvak5k4*acc49(15)
      acc49(94)=Qspk2*acc49(70)
      acc49(95)=Qspvak2k1*acc49(19)
      acc49(96)=Qspvak5k2*acc49(14)
      acc49(90)=acc49(90)+acc49(91)+acc49(96)+acc49(95)+acc49(94)+acc49(93)+acc&
      &49(17)+acc49(92)
      acc49(90)=Qspe3*acc49(90)
      acc49(91)=-Qspk2*acc49(75)
      acc49(92)=Qspvak2k1*acc49(73)
      acc49(93)=Qspvak5k2*acc49(64)
      acc49(94)=Qspvae3k1*acc49(38)
      acc49(95)=Qspvak5e3*acc49(42)
      acc49(91)=acc49(95)+acc49(94)+acc49(93)+acc49(92)+acc49(44)+acc49(91)
      acc49(91)=Qspk4*acc49(91)
      acc49(92)=Qspk3*acc49(30)
      acc49(93)=Qspvak3k1*acc49(28)
      acc49(94)=Qspvak5k3*acc49(36)
      acc49(95)=Qspk2*acc49(62)
      acc49(96)=Qspvak2k1*acc49(1)
      acc49(97)=Qspvak5k2*acc49(8)
      acc49(98)=-acc49(69)*mu2**2
      brack=acc49(87)+acc49(88)+acc49(89)+acc49(90)+acc49(91)+acc49(92)+acc49(9&
      &3)+acc49(94)+acc49(95)+acc49(96)+acc49(97)+acc49(98)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram49_sign, shift => diagram49_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd49h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d49
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(-Q_ext(4),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d49 = 0.0_ki
      d49 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d49, ki), aimag(d49), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd49h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d49
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(-Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d49 = 0.0_ki
      d49 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d49, ki), aimag(d49), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d49h0l1
