module     dgaad_d64h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d64h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd64h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc64(39)
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak4k3
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspk3
      complex(ki) :: Qspvae3k1
      complex(ki) :: QspQ
      complex(ki) :: Qspk1
      complex(ki) :: Qspe2
      complex(ki) :: Qspk2
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspvae2k1
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspk3 = dotproduct(Q,k3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      QspQ = dotproduct(Q,Q)
      Qspk1 = dotproduct(Q,k1)
      Qspe2 = dotproduct(Q,e2)
      Qspk2 = dotproduct(Q,k2)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      acc64(1)=abb64(2)
      acc64(2)=abb64(3)
      acc64(3)=abb64(4)
      acc64(4)=abb64(5)
      acc64(5)=abb64(6)
      acc64(6)=abb64(7)
      acc64(7)=abb64(8)
      acc64(8)=abb64(9)
      acc64(9)=abb64(10)
      acc64(10)=abb64(11)
      acc64(11)=abb64(12)
      acc64(12)=abb64(14)
      acc64(13)=abb64(15)
      acc64(14)=abb64(16)
      acc64(15)=abb64(17)
      acc64(16)=abb64(19)
      acc64(17)=abb64(20)
      acc64(18)=abb64(21)
      acc64(19)=abb64(22)
      acc64(20)=abb64(23)
      acc64(21)=abb64(24)
      acc64(22)=abb64(25)
      acc64(23)=abb64(26)
      acc64(24)=abb64(27)
      acc64(25)=abb64(28)
      acc64(26)=abb64(29)
      acc64(27)=abb64(33)
      acc64(28)=abb64(35)
      acc64(29)=abb64(36)
      acc64(30)=Qspvak4k1*acc64(25)
      acc64(31)=Qspvak5k1*acc64(3)
      acc64(30)=acc64(31)+acc64(17)+acc64(30)
      acc64(30)=Qspe3*acc64(30)
      acc64(31)=acc64(24)*Qspvak4k3
      acc64(32)=acc64(18)*Qspvak5k3
      acc64(33)=acc64(4)*Qspvak3k1
      acc64(34)=Qspk3*acc64(20)
      acc64(35)=Qspvak4k1*acc64(15)
      acc64(36)=Qspvak5k1*acc64(13)
      acc64(37)=Qspvae3k1*acc64(23)
      acc64(38)=QspQ*acc64(19)
      acc64(39)=Qspk1*acc64(29)
      acc64(30)=acc64(30)+acc64(39)+acc64(38)+acc64(37)+acc64(36)+acc64(35)+acc&
      &64(34)+acc64(33)+acc64(12)+acc64(31)+acc64(32)
      acc64(30)=Qspe2*acc64(30)
      acc64(31)=Qspk2*acc64(22)
      acc64(32)=Qspvak2k1*acc64(5)
      acc64(33)=QspQ*acc64(8)
      acc64(34)=Qspk1*acc64(9)
      acc64(35)=Qspvae2k1*acc64(11)
      acc64(31)=acc64(35)+acc64(34)+acc64(33)+acc64(32)+acc64(10)+acc64(31)
      acc64(31)=Qspe3*acc64(31)
      acc64(32)=-Qspk1+Qspk3
      acc64(32)=acc64(16)*acc64(32)
      acc64(33)=QspQ*acc64(14)
      acc64(32)=acc64(33)+acc64(2)+acc64(32)
      acc64(32)=Qspvae2k1*acc64(32)
      acc64(33)=Qspk2*acc64(21)
      acc64(34)=Qspvak2k1*acc64(1)
      acc64(35)=Qspvae3k1*acc64(27)
      acc64(35)=acc64(6)+acc64(35)
      acc64(35)=QspQ*acc64(35)
      acc64(36)=Qspvae3k1*acc64(26)
      acc64(36)=acc64(28)+acc64(36)
      acc64(36)=Qspk1*acc64(36)
      brack=acc64(7)+acc64(30)+acc64(31)+acc64(32)+acc64(33)+acc64(34)+acc64(35&
      &)+acc64(36)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram64_sign, shift => diagram64_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd64h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d64
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d64 = 0.0_ki
      d64 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d64, ki), aimag(d64), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd64h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d64
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d64 = 0.0_ki
      d64 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d64, ki), aimag(d64), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d64h0l1
