module     dgaad_d82h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d82h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd82h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc82(54)
      complex(ki) :: Qspe2
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae4k5
      complex(ki) :: Qspvae2k5
      complex(ki) :: Qspvae2k3
      complex(ki) :: Qspvae4k3
      complex(ki) :: Qspvak3e2
      complex(ki) :: Qspvak3e4
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspvak1e2
      complex(ki) :: QspQ
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspvak4k3
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspk4
      complex(ki) :: Qspvak3k4
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspvak2k3
      complex(ki) :: Qspk2
      complex(ki) :: Qspvak3k2
      Qspe2 = dotproduct(Q,e2)
      Qspe4 = dotproduct(Q,e4)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      Qspvae2k5 = dotproduct(Q,spvae2k5)
      Qspvae2k3 = dotproduct(Q,spvae2k3)
      Qspvae4k3 = dotproduct(Q,spvae4k3)
      Qspvak3e2 = dotproduct(Q,spvak3e2)
      Qspvak3e4 = dotproduct(Q,spvak3e4)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      QspQ = dotproduct(Q,Q)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspk4 = dotproduct(Q,k4)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspvak2k3 = dotproduct(Q,spvak2k3)
      Qspk2 = dotproduct(Q,k2)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      acc82(1)=abb82(4)
      acc82(2)=abb82(5)
      acc82(3)=abb82(6)
      acc82(4)=abb82(7)
      acc82(5)=abb82(8)
      acc82(6)=abb82(9)
      acc82(7)=abb82(10)
      acc82(8)=abb82(11)
      acc82(9)=abb82(12)
      acc82(10)=abb82(13)
      acc82(11)=abb82(14)
      acc82(12)=abb82(15)
      acc82(13)=abb82(16)
      acc82(14)=abb82(17)
      acc82(15)=abb82(18)
      acc82(16)=abb82(19)
      acc82(17)=abb82(20)
      acc82(18)=abb82(21)
      acc82(19)=abb82(22)
      acc82(20)=abb82(23)
      acc82(21)=abb82(24)
      acc82(22)=abb82(25)
      acc82(23)=abb82(26)
      acc82(24)=abb82(28)
      acc82(25)=abb82(29)
      acc82(26)=abb82(30)
      acc82(27)=abb82(31)
      acc82(28)=abb82(32)
      acc82(29)=abb82(33)
      acc82(30)=abb82(35)
      acc82(31)=abb82(36)
      acc82(32)=abb82(38)
      acc82(33)=abb82(39)
      acc82(34)=abb82(40)
      acc82(35)=abb82(41)
      acc82(36)=abb82(42)
      acc82(37)=abb82(43)
      acc82(38)=abb82(46)
      acc82(39)=abb82(48)
      acc82(40)=abb82(49)
      acc82(41)=abb82(50)
      acc82(42)=-acc82(17)*Qspe2
      acc82(43)=-acc82(24)*Qspe4
      acc82(44)=-acc82(29)*Qspvae4k5
      acc82(45)=-acc82(31)*Qspvae2k5
      acc82(46)=-acc82(33)*Qspvae2k3
      acc82(47)=-acc82(34)*Qspvae4k3
      acc82(48)=acc82(35)*Qspvak3e2
      acc82(49)=acc82(36)*Qspvak3e4
      acc82(50)=acc82(40)*Qspvak1e4
      acc82(51)=acc82(41)*Qspvak1e2
      acc82(42)=acc82(42)+acc82(43)+acc82(51)+acc82(50)+acc82(49)+acc82(48)+acc&
      &82(47)+acc82(46)+acc82(45)+acc82(44)
      acc82(43)=mu2-QspQ
      acc82(42)=acc82(43)*acc82(42)
      acc82(43)=acc82(9)*Qspvak3e4
      acc82(44)=acc82(11)*Qspe4
      acc82(45)=acc82(12)*Qspvak4k5
      acc82(46)=acc82(14)*Qspvak4k3
      acc82(47)=acc82(16)*Qspvak1k4
      acc82(48)=acc82(18)*Qspk4
      acc82(49)=acc82(19)*Qspvak3k4
      acc82(50)=acc82(28)*Qspvae4k5
      acc82(51)=acc82(32)*Qspvae4k3
      acc82(52)=acc82(39)*Qspvak1e4
      acc82(43)=acc82(52)+acc82(51)+acc82(50)+acc82(49)+acc82(48)+acc82(47)+acc&
      &82(46)+acc82(45)+acc82(44)+acc82(43)+acc82(5)
      acc82(43)=Qspe2*acc82(43)
      acc82(44)=acc82(6)*Qspvak1e2
      acc82(45)=acc82(15)*Qspvak1k2
      acc82(46)=acc82(21)*Qspvak2k5
      acc82(47)=acc82(23)*Qspvak2k3
      acc82(48)=acc82(25)*Qspk2
      acc82(49)=acc82(26)*Qspvak3k2
      acc82(50)=acc82(30)*Qspvae2k5
      acc82(51)=acc82(37)*Qspvae2k3
      acc82(52)=acc82(38)*Qspvak3e2
      acc82(44)=acc82(52)+acc82(51)+acc82(50)+acc82(49)+acc82(48)+acc82(47)+acc&
      &82(46)+acc82(45)+acc82(7)+acc82(44)
      acc82(44)=Qspe4*acc82(44)
      acc82(45)=acc82(1)*Qspvak4k3
      acc82(46)=acc82(2)*Qspvak3k2
      acc82(47)=acc82(3)*Qspvak1k4
      acc82(48)=acc82(4)*Qspvak2k5
      acc82(49)=acc82(8)*Qspvak4k5
      acc82(50)=acc82(10)*Qspvak1k2
      acc82(51)=acc82(13)*Qspk4
      acc82(52)=acc82(20)*Qspvak2k3
      acc82(53)=acc82(22)*Qspk2
      acc82(54)=acc82(27)*Qspvak3k4
      brack=acc82(42)+acc82(43)+acc82(44)+acc82(45)+acc82(46)+acc82(47)+acc82(4&
      &8)+acc82(49)+acc82(50)+acc82(51)+acc82(52)+acc82(53)+acc82(54)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram82_sign, shift => diagram82_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd82h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d82
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d82 = 0.0_ki
      d82 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d82, ki), aimag(d82), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd82h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d82
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d82 = 0.0_ki
      d82 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d82, ki), aimag(d82), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d82h8l1
