module     ugaau_d29h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d29h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd29h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc29(99)
      complex(ki) :: Qspk2
      complex(ki) :: Qspk4
      complex(ki) :: QspQ
      complex(ki) :: Qspvak3e4
      complex(ki) :: Qspvae4k3
      complex(ki) :: Qspvak4e4
      complex(ki) :: Qspvae4k4
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspvak2e4
      complex(ki) :: Qspvae4k2
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3e4
      complex(ki) :: Qspvae4e3
      complex(ki) :: Qspk3
      complex(ki) :: Qspe2
      complex(ki) :: Qspvae2e4
      complex(ki) :: Qspvae4e2
      Qspk2 = dotproduct(Q,k2)
      Qspk4 = dotproduct(Q,k4)
      QspQ = dotproduct(Q,Q)
      Qspvak3e4 = dotproduct(Q,spvak3e4)
      Qspvae4k3 = dotproduct(Q,spvae4k3)
      Qspvak4e4 = dotproduct(Q,spvak4e4)
      Qspvae4k4 = dotproduct(Q,spvae4k4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspvak2e4 = dotproduct(Q,spvak2e4)
      Qspvae4k2 = dotproduct(Q,spvae4k2)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3e4 = dotproduct(Q,spvae3e4)
      Qspvae4e3 = dotproduct(Q,spvae4e3)
      Qspk3 = dotproduct(Q,k3)
      Qspe2 = dotproduct(Q,e2)
      Qspvae2e4 = dotproduct(Q,spvae2e4)
      Qspvae4e2 = dotproduct(Q,spvae4e2)
      acc29(1)=abb29(2)
      acc29(2)=abb29(3)
      acc29(3)=abb29(4)
      acc29(4)=abb29(5)
      acc29(5)=abb29(6)
      acc29(6)=abb29(7)
      acc29(7)=abb29(8)
      acc29(8)=abb29(9)
      acc29(9)=abb29(10)
      acc29(10)=abb29(11)
      acc29(11)=abb29(12)
      acc29(12)=abb29(13)
      acc29(13)=abb29(14)
      acc29(14)=abb29(15)
      acc29(15)=abb29(16)
      acc29(16)=abb29(17)
      acc29(17)=abb29(18)
      acc29(18)=abb29(19)
      acc29(19)=abb29(20)
      acc29(20)=abb29(21)
      acc29(21)=abb29(22)
      acc29(22)=abb29(23)
      acc29(23)=abb29(24)
      acc29(24)=abb29(25)
      acc29(25)=abb29(26)
      acc29(26)=abb29(27)
      acc29(27)=abb29(28)
      acc29(28)=abb29(29)
      acc29(29)=abb29(30)
      acc29(30)=abb29(31)
      acc29(31)=abb29(32)
      acc29(32)=abb29(33)
      acc29(33)=abb29(34)
      acc29(34)=abb29(35)
      acc29(35)=abb29(36)
      acc29(36)=abb29(37)
      acc29(37)=abb29(38)
      acc29(38)=abb29(39)
      acc29(39)=abb29(40)
      acc29(40)=abb29(41)
      acc29(41)=abb29(42)
      acc29(42)=abb29(43)
      acc29(43)=abb29(44)
      acc29(44)=abb29(45)
      acc29(45)=abb29(46)
      acc29(46)=abb29(47)
      acc29(47)=abb29(48)
      acc29(48)=abb29(49)
      acc29(49)=abb29(50)
      acc29(50)=abb29(51)
      acc29(51)=abb29(52)
      acc29(52)=abb29(53)
      acc29(53)=abb29(54)
      acc29(54)=abb29(55)
      acc29(55)=abb29(56)
      acc29(56)=abb29(57)
      acc29(57)=abb29(58)
      acc29(58)=abb29(59)
      acc29(59)=abb29(60)
      acc29(60)=abb29(61)
      acc29(61)=abb29(62)
      acc29(62)=abb29(63)
      acc29(63)=abb29(64)
      acc29(64)=abb29(65)
      acc29(65)=abb29(66)
      acc29(66)=abb29(68)
      acc29(67)=abb29(69)
      acc29(68)=abb29(70)
      acc29(69)=abb29(71)
      acc29(70)=abb29(72)
      acc29(71)=abb29(73)
      acc29(72)=abb29(74)
      acc29(73)=abb29(75)
      acc29(74)=abb29(76)
      acc29(75)=abb29(77)
      acc29(76)=abb29(78)
      acc29(77)=abb29(79)
      acc29(78)=abb29(80)
      acc29(79)=abb29(81)
      acc29(80)=abb29(82)
      acc29(81)=abb29(83)
      acc29(82)=abb29(84)
      acc29(83)=abb29(85)
      acc29(84)=abb29(87)
      acc29(85)=abb29(90)
      acc29(86)=abb29(93)
      acc29(87)=Qspk2-Qspk4
      acc29(88)=-acc29(47)*acc29(87)
      acc29(89)=QspQ-mu2
      acc29(90)=acc29(38)*acc29(89)
      acc29(91)=Qspvak3e4*acc29(65)
      acc29(92)=Qspvae4k3*acc29(83)
      acc29(93)=Qspvak4e4*acc29(82)
      acc29(94)=Qspvae4k4*acc29(76)
      acc29(95)=Qspvae4k1*acc29(26)
      acc29(96)=Qspvak5e4*acc29(21)
      acc29(97)=Qspvak2e4*acc29(44)
      acc29(98)=Qspvae4k2*acc29(41)
      acc29(99)=acc29(5)*Qspe4
      acc29(99)=acc29(9)+acc29(99)
      acc29(99)=Qspvak5k1*acc29(99)
      acc29(88)=acc29(99)+acc29(98)+acc29(97)+acc29(96)+acc29(95)+acc29(94)+acc&
      &29(93)+acc29(92)+acc29(18)+acc29(91)+acc29(90)+acc29(88)
      acc29(88)=Qspe3*acc29(88)
      acc29(90)=Qspvae4k1*acc29(49)
      acc29(91)=Qspvak5e4*acc29(30)
      acc29(92)=Qspvae3e4*acc29(71)
      acc29(93)=Qspvae4e3*acc29(55)
      acc29(90)=-acc29(90)+acc29(91)+acc29(92)+acc29(93)
      acc29(91)=-mu2*acc29(90)
      acc29(92)=Qspvae4k1*acc29(50)
      acc29(93)=Qspvak5e4*acc29(45)
      acc29(94)=Qspvae3e4*acc29(66)
      acc29(95)=Qspvae4e3*acc29(62)
      acc29(92)=acc29(95)+acc29(94)+acc29(93)+acc29(53)+acc29(92)
      acc29(92)=Qspk3*acc29(92)
      acc29(90)=acc29(34)+acc29(90)
      acc29(90)=QspQ*acc29(90)
      acc29(93)=Qspvak3e4*acc29(73)
      acc29(94)=Qspvae4k3*acc29(64)
      acc29(95)=Qspvae3e4*acc29(35)
      acc29(96)=Qspvae4e3*acc29(32)
      acc29(93)=acc29(96)+acc29(95)+acc29(94)+acc29(4)+acc29(93)
      acc29(93)=Qspvak5k1*acc29(93)
      acc29(87)=acc29(43)*acc29(87)
      acc29(94)=Qspvak4e4*acc29(81)
      acc29(95)=Qspvae4k4*acc29(75)
      acc29(96)=Qspvae3e4*acc29(22)
      acc29(97)=Qspvae4e3*acc29(52)
      acc29(98)=Qspvak2e4*acc29(19)
      acc29(99)=Qspvae4k2*acc29(11)
      acc29(87)=acc29(88)+acc29(93)+acc29(90)+acc29(92)+acc29(91)+acc29(99)+acc&
      &29(98)+acc29(97)+acc29(96)+acc29(95)+acc29(94)+acc29(16)+acc29(87)
      acc29(87)=Qspe2*acc29(87)
      acc29(88)=-QspQ+Qspk3-Qspk4
      acc29(88)=acc29(46)*acc29(88)
      acc29(90)=Qspk2*acc29(68)
      acc29(91)=Qspvae2e4*acc29(10)
      acc29(92)=Qspvae4e2*acc29(2)
      acc29(93)=Qspvak4e4*acc29(79)
      acc29(94)=Qspvae4k4*acc29(78)
      acc29(95)=Qspvae4k1*acc29(67)
      acc29(96)=Qspvak5e4*acc29(48)
      acc29(97)=Qspvak2e4*acc29(51)
      acc29(98)=Qspvae4k2*acc29(63)
      acc29(99)=mu2*acc29(68)
      acc29(88)=acc29(99)+acc29(98)+acc29(97)+acc29(90)+acc29(96)+acc29(95)+acc&
      &29(94)+acc29(93)+acc29(92)+acc29(6)+acc29(91)+acc29(88)
      acc29(88)=QspQ*acc29(88)
      acc29(89)=-acc29(23)*acc29(89)
      acc29(91)=Qspvae2e4*acc29(12)
      acc29(92)=Qspvae4e2*acc29(54)
      acc29(93)=Qspk2*acc29(86)
      acc29(94)=Qspvak2e4*acc29(56)
      acc29(95)=Qspvae4k2*acc29(59)
      acc29(89)=acc29(95)+acc29(94)+acc29(93)+acc29(92)+acc29(7)+acc29(91)+acc2&
      &9(89)
      acc29(89)=Qspvak5k1*acc29(89)
      acc29(91)=Qspk4*acc29(39)
      acc29(92)=Qspvak4e4*acc29(80)
      acc29(93)=Qspvae4k4*acc29(70)
      acc29(94)=Qspvae4k1*acc29(14)
      acc29(95)=Qspvak5e4*acc29(3)
      acc29(96)=Qspk2*acc29(40)
      acc29(97)=Qspvak2e4*acc29(24)
      acc29(98)=Qspvae4k2*acc29(28)
      acc29(99)=QspQ*acc29(33)
      acc29(89)=acc29(89)+acc29(99)+acc29(98)+acc29(97)+acc29(96)+acc29(95)+acc&
      &29(94)+acc29(93)+acc29(92)+acc29(8)+acc29(91)
      acc29(89)=Qspe3*acc29(89)
      acc29(91)=Qspvae2e4*acc29(42)
      acc29(92)=Qspvae4e2*acc29(60)
      acc29(93)=Qspvae3e4*acc29(57)
      acc29(94)=Qspvae4e3*acc29(77)
      acc29(91)=-acc29(91)-acc29(92)+acc29(93)+acc29(94)
      acc29(92)=mu2*acc29(91)
      acc29(91)=acc29(13)-acc29(91)
      acc29(91)=QspQ*acc29(91)
      acc29(93)=Qspvak3e4*acc29(72)
      acc29(94)=Qspvae4k3*acc29(27)
      acc29(95)=Qspk2*acc29(17)
      acc29(96)=Qspvak2e4*acc29(61)
      acc29(97)=Qspvae4k2*acc29(74)
      acc29(91)=acc29(91)+acc29(92)+acc29(97)+acc29(96)+acc29(95)+acc29(94)+acc&
      &29(69)+acc29(93)
      acc29(91)=Qspvak5k1*acc29(91)
      acc29(92)=Qspvae4k1*acc29(29)
      acc29(93)=Qspvak5e4*acc29(25)
      acc29(94)=Qspvak2e4*acc29(85)
      acc29(95)=Qspvae4k2*acc29(84)
      acc29(90)=acc29(95)+acc29(94)-acc29(90)+acc29(93)+acc29(1)+acc29(92)
      acc29(90)=Qspk3*acc29(90)
      acc29(92)=Qspk4*acc29(37)
      acc29(93)=Qspvak4e4*acc29(36)
      acc29(94)=Qspvae4k4*acc29(31)
      acc29(95)=Qspk2*acc29(58)
      acc29(96)=Qspvak2e4*acc29(20)
      acc29(97)=Qspvae4k2*acc29(15)
      acc29(98)=-acc29(46)*mu2**2
      brack=acc29(87)+acc29(88)+acc29(89)+acc29(90)+acc29(91)+acc29(92)+acc29(9&
      &3)+acc29(94)+acc29(95)+acc29(96)+acc29(97)+acc29(98)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram29_sign, shift => diagram29_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd29h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d29
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(+Q_ext(4),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d29 = 0.0_ki
      d29 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d29, ki), aimag(d29), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd29h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d29
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(+Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d29 = 0.0_ki
      d29 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d29, ki), aimag(d29), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d29h0l1
