module     ugaau_d39h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d39h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd39h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc39(101)
      complex(ki) :: Qspk3
      complex(ki) :: QspQ
      complex(ki) :: Qspk2
      complex(ki) :: Qspk4
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspe4
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspe2
      Qspk3 = dotproduct(Q,k3)
      QspQ = dotproduct(Q,Q)
      Qspk2 = dotproduct(Q,k2)
      Qspk4 = dotproduct(Q,k4)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspe4 = dotproduct(Q,e4)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspe2 = dotproduct(Q,e2)
      acc39(1)=abb39(2)
      acc39(2)=abb39(3)
      acc39(3)=abb39(4)
      acc39(4)=abb39(5)
      acc39(5)=abb39(6)
      acc39(6)=abb39(7)
      acc39(7)=abb39(8)
      acc39(8)=abb39(9)
      acc39(9)=abb39(10)
      acc39(10)=abb39(11)
      acc39(11)=abb39(12)
      acc39(12)=abb39(13)
      acc39(13)=abb39(14)
      acc39(14)=abb39(15)
      acc39(15)=abb39(16)
      acc39(16)=abb39(17)
      acc39(17)=abb39(18)
      acc39(18)=abb39(19)
      acc39(19)=abb39(20)
      acc39(20)=abb39(21)
      acc39(21)=abb39(22)
      acc39(22)=abb39(23)
      acc39(23)=abb39(24)
      acc39(24)=abb39(25)
      acc39(25)=abb39(26)
      acc39(26)=abb39(27)
      acc39(27)=abb39(28)
      acc39(28)=abb39(29)
      acc39(29)=abb39(30)
      acc39(30)=abb39(31)
      acc39(31)=abb39(32)
      acc39(32)=abb39(33)
      acc39(33)=abb39(34)
      acc39(34)=abb39(35)
      acc39(35)=abb39(36)
      acc39(36)=abb39(37)
      acc39(37)=abb39(38)
      acc39(38)=abb39(39)
      acc39(39)=abb39(40)
      acc39(40)=abb39(41)
      acc39(41)=abb39(42)
      acc39(42)=abb39(43)
      acc39(43)=abb39(44)
      acc39(44)=abb39(45)
      acc39(45)=abb39(46)
      acc39(46)=abb39(47)
      acc39(47)=abb39(48)
      acc39(48)=abb39(49)
      acc39(49)=abb39(50)
      acc39(50)=abb39(51)
      acc39(51)=abb39(52)
      acc39(52)=abb39(53)
      acc39(53)=abb39(54)
      acc39(54)=abb39(55)
      acc39(55)=abb39(56)
      acc39(56)=abb39(57)
      acc39(57)=abb39(58)
      acc39(58)=abb39(59)
      acc39(59)=abb39(60)
      acc39(60)=abb39(61)
      acc39(61)=abb39(62)
      acc39(62)=abb39(63)
      acc39(63)=abb39(64)
      acc39(64)=abb39(65)
      acc39(65)=abb39(66)
      acc39(66)=abb39(67)
      acc39(67)=abb39(68)
      acc39(68)=abb39(69)
      acc39(69)=abb39(70)
      acc39(70)=abb39(71)
      acc39(71)=abb39(72)
      acc39(72)=abb39(73)
      acc39(73)=abb39(75)
      acc39(74)=abb39(76)
      acc39(75)=abb39(77)
      acc39(76)=abb39(78)
      acc39(77)=abb39(79)
      acc39(78)=abb39(80)
      acc39(79)=abb39(82)
      acc39(80)=abb39(83)
      acc39(81)=abb39(84)
      acc39(82)=abb39(85)
      acc39(83)=abb39(86)
      acc39(84)=abb39(87)
      acc39(85)=abb39(88)
      acc39(86)=abb39(89)
      acc39(87)=Qspk3-mu2
      acc39(87)=acc39(75)*acc39(87)
      acc39(88)=QspQ+Qspk2+Qspk4
      acc39(88)=acc39(70)*acc39(88)
      acc39(89)=Qspvae2k1*acc39(52)
      acc39(90)=Qspvak5e2*acc39(48)
      acc39(91)=Qspvak3k1*acc39(38)
      acc39(92)=Qspvak4k1*acc39(86)
      acc39(93)=Qspvak5k3*acc39(74)
      acc39(94)=Qspvak5k4*acc39(85)
      acc39(95)=Qspvak2k1*acc39(46)
      acc39(96)=Qspvak5k2*acc39(50)
      acc39(97)=Qspvae4k1*acc39(63)
      acc39(98)=Qspvak5e4*acc39(61)
      acc39(87)=acc39(98)+acc39(97)+acc39(96)+acc39(95)+acc39(94)+acc39(93)+acc&
      &39(92)+acc39(91)+acc39(90)+acc39(30)+acc39(89)+acc39(88)+acc39(87)
      acc39(87)=QspQ*acc39(87)
      acc39(88)=QspQ-mu2
      acc39(89)=acc39(68)*acc39(88)
      acc39(90)=Qspvae2k1*acc39(10)
      acc39(91)=Qspvak5e2*acc39(4)
      acc39(92)=Qspk2*acc39(72)
      acc39(93)=Qspvak2k1*acc39(67)
      acc39(94)=Qspvak5k2*acc39(54)
      acc39(89)=acc39(94)+acc39(93)+acc39(92)+acc39(91)+acc39(21)+acc39(90)+acc&
      &39(89)
      acc39(89)=Qspe4*acc39(89)
      acc39(90)=Qspk3+Qspk4
      acc39(91)=acc39(40)*acc39(90)
      acc39(92)=Qspvak3k1*acc39(18)
      acc39(93)=Qspvak4k1*acc39(76)
      acc39(94)=Qspvak5k3*acc39(41)
      acc39(95)=Qspvak5k4*acc39(83)
      acc39(96)=Qspk2*acc39(69)
      acc39(97)=Qspvak2k1*acc39(57)
      acc39(98)=Qspvak5k2*acc39(33)
      acc39(99)=Qspvae4k1*acc39(20)
      acc39(100)=Qspvak5e4*acc39(15)
      acc39(101)=QspQ*acc39(66)
      acc39(89)=acc39(89)+acc39(101)+acc39(100)+acc39(99)+acc39(98)+acc39(97)+a&
      &cc39(96)+acc39(95)+acc39(94)+acc39(93)+acc39(92)+acc39(16)+acc39(91)
      acc39(89)=Qspe3*acc39(89)
      acc39(90)=acc39(45)*acc39(90)
      acc39(88)=acc39(44)*acc39(88)
      acc39(91)=Qspvak3k1*acc39(37)
      acc39(92)=Qspvak4k1*acc39(42)
      acc39(93)=Qspvak5k3*acc39(35)
      acc39(94)=Qspvak5k4*acc39(39)
      acc39(95)=Qspvae4k1*acc39(27)
      acc39(96)=Qspvak5e4*acc39(32)
      acc39(97)=acc39(1)*Qspvak5k1
      acc39(97)=acc39(22)+acc39(97)
      acc39(97)=Qspe4*acc39(97)
      acc39(88)=acc39(97)+acc39(96)+acc39(95)+acc39(94)+acc39(93)+acc39(92)+acc&
      &39(91)+acc39(26)+acc39(88)+acc39(90)
      acc39(88)=Qspe3*acc39(88)
      acc39(90)=Qspvae3k1*acc39(59)
      acc39(91)=Qspvae4k1*acc39(56)
      acc39(92)=Qspvak5e3*acc39(60)
      acc39(93)=Qspvak5e4*acc39(53)
      acc39(90)=-acc39(90)+acc39(91)+acc39(92)-acc39(93)
      acc39(91)=mu2*acc39(90)
      acc39(92)=Qspvae3k1*acc39(81)
      acc39(93)=Qspvae4k1*acc39(79)
      acc39(94)=Qspvak5e3*acc39(78)
      acc39(95)=Qspvak5e4*acc39(73)
      acc39(92)=acc39(95)+acc39(94)+acc39(93)+acc39(24)+acc39(92)
      acc39(92)=Qspk3*acc39(92)
      acc39(90)=acc39(23)-acc39(90)
      acc39(90)=QspQ*acc39(90)
      acc39(93)=Qspvak3k1*acc39(31)
      acc39(94)=Qspvak5k3*acc39(19)
      acc39(95)=Qspvae3k1*acc39(28)
      acc39(96)=Qspvak5e3*acc39(25)
      acc39(93)=acc39(96)+acc39(95)+acc39(94)+acc39(6)+acc39(93)
      acc39(93)=Qspe4*acc39(93)
      acc39(94)=Qspk4*acc39(43)
      acc39(95)=Qspvak4k1*acc39(13)
      acc39(96)=Qspvak5k4*acc39(84)
      acc39(97)=Qspvae3k1*acc39(80)
      acc39(98)=Qspvak5e3*acc39(77)
      acc39(88)=acc39(88)+acc39(93)+acc39(90)+acc39(92)+acc39(91)+acc39(98)+acc&
      &39(97)+acc39(96)+acc39(95)+acc39(14)+acc39(94)
      acc39(88)=Qspe2*acc39(88)
      acc39(90)=Qspvae2k1*acc39(2)
      acc39(91)=Qspvak5e2*acc39(8)
      acc39(92)=Qspvae3k1*acc39(82)
      acc39(93)=Qspvak5e3*acc39(55)
      acc39(90)=-acc39(90)+acc39(91)+acc39(92)-acc39(93)
      acc39(91)=mu2*acc39(90)
      acc39(90)=acc39(58)-acc39(90)
      acc39(90)=QspQ*acc39(90)
      acc39(92)=Qspvak3k1*acc39(11)
      acc39(93)=Qspvak5k3*acc39(5)
      acc39(94)=Qspk2*acc39(64)
      acc39(95)=Qspvak2k1*acc39(9)
      acc39(96)=Qspvak5k2*acc39(3)
      acc39(90)=acc39(90)+acc39(91)+acc39(96)+acc39(95)+acc39(94)+acc39(93)+acc&
      &39(7)+acc39(92)
      acc39(90)=Qspe4*acc39(90)
      acc39(91)=Qspk2*acc39(75)
      acc39(92)=Qspvak2k1*acc39(71)
      acc39(93)=Qspvak5k2*acc39(65)
      acc39(94)=Qspvae4k1*acc39(47)
      acc39(95)=Qspvak5e4*acc39(51)
      acc39(91)=acc39(95)+acc39(94)+acc39(93)+acc39(92)+acc39(49)+acc39(91)
      acc39(91)=Qspk3*acc39(91)
      acc39(92)=Qspk4*acc39(36)
      acc39(93)=Qspvak4k1*acc39(29)
      acc39(94)=Qspvak5k4*acc39(34)
      acc39(95)=Qspk2*acc39(62)
      acc39(96)=Qspvak2k1*acc39(12)
      acc39(97)=Qspvak5k2*acc39(17)
      acc39(98)=acc39(70)*mu2**2
      brack=acc39(87)+acc39(88)+acc39(89)+acc39(90)+acc39(91)+acc39(92)+acc39(9&
      &3)+acc39(94)+acc39(95)+acc39(96)+acc39(97)+acc39(98)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram39_sign, shift => diagram39_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd39h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d39
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(-Q_ext(4),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d39 = 0.0_ki
      d39 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d39, ki), aimag(d39), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd39h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d39
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(-Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d39 = 0.0_ki
      d39 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d39, ki), aimag(d39), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d39h0l1
