module     ugaau_d65h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d65h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd65h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc65(41)
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspvak4e3
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspvak4k2
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvak4k3
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspe3
      complex(ki) :: QspQ
      complex(ki) :: Qspk2
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspvak4e3 = dotproduct(Q,spvak4e3)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspvak4k2 = dotproduct(Q,spvak4k2)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspe3 = dotproduct(Q,e3)
      QspQ = dotproduct(Q,Q)
      Qspk2 = dotproduct(Q,k2)
      acc65(1)=abb65(3)
      acc65(2)=abb65(4)
      acc65(3)=abb65(5)
      acc65(4)=abb65(6)
      acc65(5)=abb65(7)
      acc65(6)=abb65(8)
      acc65(7)=abb65(9)
      acc65(8)=abb65(10)
      acc65(9)=abb65(11)
      acc65(10)=abb65(12)
      acc65(11)=abb65(13)
      acc65(12)=abb65(14)
      acc65(13)=abb65(15)
      acc65(14)=abb65(16)
      acc65(15)=abb65(17)
      acc65(16)=abb65(18)
      acc65(17)=abb65(19)
      acc65(18)=abb65(20)
      acc65(19)=abb65(21)
      acc65(20)=abb65(23)
      acc65(21)=abb65(25)
      acc65(22)=abb65(26)
      acc65(23)=abb65(28)
      acc65(24)=abb65(29)
      acc65(25)=abb65(30)
      acc65(26)=abb65(31)
      acc65(27)=abb65(32)
      acc65(28)=abb65(33)
      acc65(29)=abb65(35)
      acc65(30)=abb65(36)
      acc65(31)=abb65(38)
      acc65(32)=acc65(8)*Qspvak2k1
      acc65(33)=acc65(10)*Qspvak4e3
      acc65(34)=acc65(11)*Qspvak5k2
      acc65(35)=acc65(12)*Qspvak5e3
      acc65(36)=acc65(16)*Qspvak4k2
      acc65(37)=acc65(21)*Qspvae3k1
      acc65(38)=acc65(29)*Qspvak4k3
      acc65(39)=acc65(30)*Qspvak5k3
      acc65(40)=Qspvak3k1*acc65(23)
      acc65(32)=acc65(40)+acc65(39)+acc65(38)+acc65(37)+acc65(36)+acc65(35)+acc&
      &65(34)+acc65(33)+acc65(32)
      acc65(32)=Qspe2*acc65(32)
      acc65(33)=Qspvak5k1*acc65(2)
      acc65(34)=Qspvak4k1*acc65(3)
      acc65(33)=acc65(34)+acc65(33)
      acc65(33)=acc65(33)*Qspe2
      acc65(34)=acc65(7)*Qspvak2k1
      acc65(35)=acc65(13)*Qspvak5k2
      acc65(36)=acc65(17)*Qspvak4k2
      acc65(37)=acc65(20)*Qspvae2k1
      acc65(33)=acc65(33)+acc65(37)+acc65(36)+acc65(35)+acc65(34)
      acc65(33)=Qspe3*acc65(33)
      acc65(34)=acc65(5)*Qspvae3k1
      acc65(35)=acc65(9)*Qspe3
      acc65(36)=acc65(14)*Qspvak5e3
      acc65(37)=acc65(18)*Qspvak4e3
      acc65(38)=acc65(24)*Qspvae2k1
      acc65(34)=acc65(38)+acc65(37)+acc65(36)+acc65(35)+acc65(34)+acc65(1)
      acc65(34)=QspQ*acc65(34)
      acc65(35)=acc65(15)*Qspvak5e3
      acc65(36)=acc65(19)*Qspvak4e3
      acc65(37)=acc65(22)*Qspvae3k1
      acc65(38)=acc65(25)*Qspvae2k1
      acc65(35)=acc65(38)+acc65(37)+acc65(36)+acc65(35)
      acc65(35)=Qspk2*acc65(35)
      acc65(36)=acc65(4)*Qspvak2k1
      acc65(37)=acc65(6)*Qspvae2k1
      acc65(38)=acc65(26)*Qspvak4k2
      acc65(39)=acc65(27)*Qspvak5k2
      acc65(40)=acc65(28)*Qspvak5k3
      acc65(41)=acc65(31)*Qspvak4k3
      brack=acc65(32)+acc65(33)+acc65(34)+acc65(35)+acc65(36)+acc65(37)+acc65(3&
      &8)+acc65(39)+acc65(40)+acc65(41)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram65_sign, shift => diagram65_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd65h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d65
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d65 = 0.0_ki
      d65 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d65, ki), aimag(d65), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd65h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d65
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d65 = 0.0_ki
      d65 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d65, ki), aimag(d65), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d65h0l1
