module     ugaau_d156h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d156h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd156h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc156(84)
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspe2
      complex(ki) :: Qspvae3k5
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspe3
      complex(ki) :: Qspk5
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1e3
      complex(ki) :: QspQ
      complex(ki) :: Qspvae4k5
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspk4
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspe2 = dotproduct(Q,e2)
      Qspvae3k5 = dotproduct(Q,spvae3k5)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspe4 = dotproduct(Q,e4)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspe3 = dotproduct(Q,e3)
      Qspk5 = dotproduct(Q,k5)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      QspQ = dotproduct(Q,Q)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspk4 = dotproduct(Q,k4)
      acc156(1)=abb156(2)
      acc156(2)=abb156(3)
      acc156(3)=abb156(4)
      acc156(4)=abb156(5)
      acc156(5)=abb156(6)
      acc156(6)=abb156(7)
      acc156(7)=abb156(8)
      acc156(8)=abb156(9)
      acc156(9)=abb156(10)
      acc156(10)=abb156(11)
      acc156(11)=abb156(12)
      acc156(12)=abb156(13)
      acc156(13)=abb156(14)
      acc156(14)=abb156(15)
      acc156(15)=abb156(16)
      acc156(16)=abb156(17)
      acc156(17)=abb156(18)
      acc156(18)=abb156(19)
      acc156(19)=abb156(20)
      acc156(20)=abb156(21)
      acc156(21)=abb156(22)
      acc156(22)=abb156(23)
      acc156(23)=abb156(24)
      acc156(24)=abb156(25)
      acc156(25)=abb156(26)
      acc156(26)=abb156(27)
      acc156(27)=abb156(28)
      acc156(28)=abb156(29)
      acc156(29)=abb156(30)
      acc156(30)=abb156(31)
      acc156(31)=abb156(32)
      acc156(32)=abb156(33)
      acc156(33)=abb156(34)
      acc156(34)=abb156(35)
      acc156(35)=abb156(36)
      acc156(36)=abb156(37)
      acc156(37)=abb156(38)
      acc156(38)=abb156(39)
      acc156(39)=abb156(40)
      acc156(40)=abb156(41)
      acc156(41)=abb156(42)
      acc156(42)=abb156(43)
      acc156(43)=abb156(44)
      acc156(44)=abb156(45)
      acc156(45)=abb156(46)
      acc156(46)=abb156(47)
      acc156(47)=abb156(48)
      acc156(48)=abb156(50)
      acc156(49)=abb156(51)
      acc156(50)=abb156(52)
      acc156(51)=abb156(53)
      acc156(52)=abb156(54)
      acc156(53)=abb156(55)
      acc156(54)=abb156(57)
      acc156(55)=abb156(59)
      acc156(56)=abb156(60)
      acc156(57)=abb156(61)
      acc156(58)=abb156(62)
      acc156(59)=abb156(65)
      acc156(60)=abb156(67)
      acc156(61)=abb156(68)
      acc156(62)=abb156(69)
      acc156(63)=abb156(70)
      acc156(64)=abb156(72)
      acc156(65)=abb156(73)
      acc156(66)=abb156(74)
      acc156(67)=abb156(75)
      acc156(68)=Qspvak1e4*Qspe2
      acc156(69)=acc156(15)*acc156(68)
      acc156(70)=acc156(17)*Qspvae3k5
      acc156(71)=acc156(19)*Qspvak1e4
      acc156(72)=acc156(20)*Qspvak1e2
      acc156(73)=acc156(25)*Qspe4
      acc156(74)=acc156(28)*Qspvak1k2
      acc156(75)=Qspe4*Qspe3
      acc156(76)=acc156(31)*acc156(75)
      acc156(77)=acc156(34)*Qspk5
      acc156(78)=Qspvae3k5*Qspe2
      acc156(79)=acc156(46)*acc156(78)
      acc156(80)=acc156(53)*Qspvak1k5
      acc156(81)=Qspvak1e3*Qspe2
      acc156(82)=acc156(56)*acc156(81)
      acc156(69)=acc156(82)+acc156(80)+acc156(79)+acc156(77)+acc156(76)+acc156(&
      &74)+acc156(73)+acc156(23)+acc156(72)+acc156(71)+acc156(70)+acc156(69)
      acc156(69)=QspQ*acc156(69)
      acc156(70)=acc156(54)*Qspe3
      acc156(70)=acc156(70)+acc156(52)
      acc156(70)=Qspvak1e4*acc156(70)
      acc156(71)=acc156(13)*Qspvak1k5
      acc156(72)=acc156(18)*Qspk5
      acc156(73)=acc156(38)*Qspvae4k5*Qspe3
      acc156(74)=acc156(45)*Qspvae3k5
      acc156(76)=acc156(62)*Qspvak1e2
      acc156(77)=Qspvak1e2*Qspe3
      acc156(79)=acc156(64)*acc156(77)
      acc156(70)=acc156(79)+acc156(76)+acc156(74)+acc156(73)+acc156(72)+acc156(&
      &71)+acc156(70)
      acc156(70)=Qspk2*acc156(70)
      acc156(71)=acc156(2)*Qspe3
      acc156(71)=acc156(8)+acc156(71)
      acc156(71)=Qspvak1k5*acc156(71)
      acc156(72)=-Qspk1-Qspk5
      acc156(72)=acc156(14)*acc156(72)
      acc156(73)=acc156(9)*Qspvak1k4
      acc156(74)=acc156(10)*Qspvak1k2
      acc156(76)=acc156(41)*Qspvae3k5
      acc156(79)=acc156(50)*Qspvak1e3
      acc156(71)=acc156(79)+acc156(76)+acc156(74)+acc156(73)+acc156(72)+acc156(&
      &71)
      acc156(71)=acc156(71)*Qspe4
      acc156(72)=acc156(24)*Qspvak1k4
      acc156(71)=acc156(72)+acc156(71)
      acc156(71)=Qspe2*acc156(71)
      acc156(72)=acc156(35)*Qspvae4k5
      acc156(73)=acc156(39)*Qspvak1k2
      acc156(74)=acc156(43)*Qspvak2k5
      acc156(76)=acc156(47)*Qspvak1k4
      acc156(79)=acc156(51)*Qspvak1e4
      acc156(80)=acc156(67)*Qspvak4k5
      acc156(72)=acc156(80)+acc156(79)+acc156(76)+acc156(74)+acc156(73)+acc156(&
      &72)
      acc156(72)=acc156(72)*Qspe2
      acc156(73)=acc156(5)*Qspvak2k5
      acc156(74)=acc156(66)*Qspvak4k5
      acc156(72)=acc156(74)+acc156(73)+acc156(72)
      acc156(72)=Qspe3*acc156(72)
      acc156(73)=-acc156(4)*Qspvak1k2
      acc156(74)=-acc156(16)*acc156(68)
      acc156(76)=-acc156(37)*QspQ
      acc156(79)=acc156(44)*acc156(78)
      acc156(80)=acc156(55)*acc156(81)
      acc156(73)=acc156(80)+acc156(79)+acc156(76)+acc156(74)+acc156(73)
      acc156(74)=Qspk4-Qspk2
      acc156(73)=acc156(74)*acc156(73)
      acc156(74)=acc156(3)*Qspe2
      acc156(76)=acc156(22)*Qspe3
      acc156(79)=acc156(29)*Qspe4
      acc156(80)=acc156(30)*acc156(75)
      acc156(74)=acc156(58)+acc156(80)+acc156(79)+acc156(76)+acc156(74)
      acc156(74)=Qspvak1k2*acc156(74)
      acc156(76)=acc156(48)*Qspe4
      acc156(79)=acc156(61)*acc156(75)
      acc156(80)=acc156(63)*Qspk4
      acc156(81)=QspQ*Qspe3
      acc156(82)=acc156(65)*acc156(81)
      acc156(76)=acc156(82)+acc156(80)+acc156(79)+acc156(59)+acc156(76)
      acc156(76)=Qspvak1e2*acc156(76)
      acc156(79)=acc156(40)*Qspe4
      acc156(80)=acc156(42)*Qspk4
      acc156(79)=acc156(80)+acc156(79)
      acc156(79)=Qspvae3k5*acc156(79)
      acc156(80)=acc156(6)*Qspe2
      acc156(82)=acc156(32)*Qspe4
      acc156(80)=acc156(57)+acc156(82)+acc156(80)
      acc156(80)=Qspvak1k5*acc156(80)
      acc156(82)=acc156(11)*Qspe4
      acc156(83)=acc156(12)*Qspe2
      acc156(82)=acc156(83)+acc156(82)+acc156(7)
      acc156(82)=Qspk5*acc156(82)
      acc156(83)=acc156(33)*Qspvae4k5
      acc156(84)=acc156(36)*Qspvak1e4
      acc156(83)=acc156(84)+acc156(83)+acc156(27)
      acc156(81)=acc156(81)*acc156(83)
      acc156(75)=acc156(1)*Qspvak2k5*acc156(75)
      acc156(78)=acc156(21)*acc156(78)
      acc156(83)=acc156(26)*QspQ**2
      acc156(68)=acc156(49)*acc156(68)
      acc156(77)=acc156(60)*acc156(77)
      brack=acc156(68)+acc156(69)+acc156(70)+acc156(71)+acc156(72)+acc156(73)+a&
      &cc156(74)+acc156(75)+acc156(76)+acc156(77)+acc156(78)+acc156(79)+acc156(&
      &80)+acc156(81)+acc156(82)+acc156(83)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram156_sign, shift => diagram156_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd156h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d156
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d156 = 0.0_ki
      d156 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d156, ki), aimag(d156), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd156h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d156
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d156 = 0.0_ki
      d156 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d156, ki), aimag(d156), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d156h8l1
