module     ugaau_d60h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d60h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd60h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc60(39)
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspvak3k2
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvak4k2
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspvae3k2
      complex(ki) :: Qspvae3k5
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak1e4
      complex(ki) :: QspQ
      complex(ki) :: Qspk4
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspe3 = dotproduct(Q,e3)
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvak4k2 = dotproduct(Q,spvak4k2)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspvae3k2 = dotproduct(Q,spvae3k2)
      Qspvae3k5 = dotproduct(Q,spvae3k5)
      Qspe4 = dotproduct(Q,e4)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      QspQ = dotproduct(Q,Q)
      Qspk4 = dotproduct(Q,k4)
      acc60(1)=abb60(3)
      acc60(2)=abb60(4)
      acc60(3)=abb60(5)
      acc60(4)=abb60(6)
      acc60(5)=abb60(7)
      acc60(6)=abb60(8)
      acc60(7)=abb60(9)
      acc60(8)=abb60(10)
      acc60(9)=abb60(11)
      acc60(10)=abb60(12)
      acc60(11)=abb60(13)
      acc60(12)=abb60(14)
      acc60(13)=abb60(15)
      acc60(14)=abb60(16)
      acc60(15)=abb60(17)
      acc60(16)=abb60(18)
      acc60(17)=abb60(19)
      acc60(18)=abb60(20)
      acc60(19)=abb60(21)
      acc60(20)=abb60(22)
      acc60(21)=abb60(23)
      acc60(22)=abb60(24)
      acc60(23)=abb60(25)
      acc60(24)=abb60(26)
      acc60(25)=abb60(27)
      acc60(26)=abb60(28)
      acc60(27)=abb60(29)
      acc60(28)=abb60(30)
      acc60(29)=abb60(31)
      acc60(30)=acc60(3)*Qspvak1k5
      acc60(31)=acc60(1)*Qspvak1k2
      acc60(30)=acc60(30)+acc60(31)
      acc60(30)=Qspe3*acc60(30)
      acc60(31)=acc60(19)*Qspvak1k3
      acc60(32)=Qspvak3k2*acc60(23)
      acc60(33)=Qspvak3k5*acc60(29)
      acc60(34)=Qspvak4k2*acc60(24)
      acc60(35)=Qspvak4k5*acc60(25)
      acc60(36)=Qspvak1k4*acc60(16)
      acc60(37)=Qspvak1e3*acc60(14)
      acc60(38)=Qspvae3k2*acc60(8)
      acc60(39)=Qspvae3k5*acc60(9)
      acc60(30)=acc60(30)+acc60(39)+acc60(38)+acc60(37)+acc60(36)+acc60(35)+acc&
      &60(34)+acc60(33)+acc60(31)+acc60(32)
      acc60(30)=Qspe4*acc60(30)
      acc60(31)=Qspvak4k2*acc60(27)
      acc60(32)=Qspvak4k5*acc60(28)
      acc60(33)=Qspvak1k4*acc60(6)
      acc60(34)=Qspvak1e4*acc60(18)
      acc60(35)=QspQ*acc60(7)
      acc60(31)=acc60(35)+acc60(34)+acc60(33)+acc60(31)+acc60(32)
      acc60(31)=Qspe3*acc60(31)
      acc60(32)=Qspvak1e3*acc60(4)
      acc60(33)=Qspvae3k2*acc60(10)
      acc60(34)=Qspvae3k5*acc60(13)
      acc60(35)=Qspvak1e4*acc60(20)
      acc60(32)=acc60(35)+acc60(34)+acc60(33)+acc60(5)+acc60(32)
      acc60(32)=QspQ*acc60(32)
      acc60(33)=Qspvak1e3*acc60(22)
      acc60(34)=Qspvae3k2*acc60(11)
      acc60(35)=Qspvae3k5*acc60(12)
      acc60(33)=acc60(35)+acc60(33)+acc60(34)
      acc60(33)=Qspk4*acc60(33)
      acc60(34)=Qspvak3k2*acc60(15)
      acc60(35)=Qspvak3k5*acc60(26)
      acc60(36)=Qspvak1k4*acc60(2)
      acc60(37)=Qspk4*acc60(21)
      acc60(37)=acc60(17)+acc60(37)
      acc60(37)=Qspvak1e4*acc60(37)
      brack=acc60(30)+acc60(31)+acc60(32)+acc60(33)+acc60(34)+acc60(35)+acc60(3&
      &6)+acc60(37)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram60_sign, shift => diagram60_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd60h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d60
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d60 = 0.0_ki
      d60 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d60, ki), aimag(d60), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd60h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d60
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d60 = 0.0_ki
      d60 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d60, ki), aimag(d60), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d60h8l1
